//
// Copyright (c) 1997, 2013, Oracle and/or its affiliates. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_x86_32.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"


//------------------------- MachOper Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachOper *State::MachOperGenerator(int opcode, Compile* C){

  switch(opcode) {
  case UNIVERSE:
    return new (C) UniverseOper( );
  case LABEL:
    return new (C) labelOper( );
  case SREGI:
    return new (C) sRegIOper( );
  case SREGP:
    return new (C) sRegPOper( );
  case SREGF:
    return new (C) sRegFOper( );
  case SREGD:
    return new (C) sRegDOper( );
  case SREGL:
    return new (C) sRegLOper( );
  case METHOD:
    return new (C) methodOper( );
  case IMMI:
    return new (C) immIOper(_leaf->get_int() );
  case IMMI0:
    return new (C) immI0Oper(_leaf->get_int() );
  case IMMI1:
    return new (C) immI1Oper(_leaf->get_int() );
  case IMMI_M1:
    return new (C) immI_M1Oper(_leaf->get_int() );
  case IMMI2:
    return new (C) immI2Oper(_leaf->get_int() );
  case IMMI8:
    return new (C) immI8Oper(_leaf->get_int() );
  case IMMI16:
    return new (C) immI16Oper(_leaf->get_int() );
  case IMMU31:
    return new (C) immU31Oper(_leaf->get_int() );
  case IMMI_32:
    return new (C) immI_32Oper(_leaf->get_int() );
  case IMMI_1_31:
    return new (C) immI_1_31Oper(_leaf->get_int() );
  case IMMI_32_63:
    return new (C) immI_32_63Oper(_leaf->get_int() );
  case IMMI_1:
    return new (C) immI_1Oper(_leaf->get_int() );
  case IMMI_2:
    return new (C) immI_2Oper(_leaf->get_int() );
  case IMMI_3:
    return new (C) immI_3Oper(_leaf->get_int() );
  case IMMP:
    return new (C) immPOper(_leaf->bottom_type()->is_ptr() );
  case IMMP0:
    return new (C) immP0Oper(_leaf->bottom_type()->is_ptr() );
  case IMML:
    return new (C) immLOper(_leaf->get_long() );
  case IMML0:
    return new (C) immL0Oper(_leaf->get_long() );
  case IMML_M1:
    return new (C) immL_M1Oper(_leaf->get_long() );
  case IMML_127:
    return new (C) immL_127Oper(_leaf->get_long() );
  case IMML_32BITS:
    return new (C) immL_32bitsOper(_leaf->get_long() );
  case IMML32:
    return new (C) immL32Oper(_leaf->get_long() );
  case IMMDPR0:
    return new (C) immDPR0Oper(_leaf->getd() );
  case IMMDPR1:
    return new (C) immDPR1Oper(_leaf->getd() );
  case IMMDPR:
    return new (C) immDPROper(_leaf->getd() );
  case IMMD:
    return new (C) immDOper(_leaf->getd() );
  case IMMD0:
    return new (C) immD0Oper(_leaf->getd() );
  case IMMFPR0:
    return new (C) immFPR0Oper(_leaf->getf() );
  case IMMFPR1:
    return new (C) immFPR1Oper(_leaf->getf() );
  case IMMFPR:
    return new (C) immFPROper(_leaf->getf() );
  case IMMF:
    return new (C) immFOper(_leaf->getf() );
  case IMMF0:
    return new (C) immF0Oper(_leaf->getf() );
  case IMMI_16:
    return new (C) immI_16Oper(_leaf->get_int() );
  case IMMI_24:
    return new (C) immI_24Oper(_leaf->get_int() );
  case IMMI_255:
    return new (C) immI_255Oper(_leaf->get_int() );
  case IMMI_65535:
    return new (C) immI_65535Oper(_leaf->get_int() );
  case RREGI:
    return new (C) rRegIOper( );
  case XREGI:
    return new (C) xRegIOper( );
  case EAXREGI:
    return new (C) eAXRegIOper( );
  case EBXREGI:
    return new (C) eBXRegIOper( );
  case ECXREGI:
    return new (C) eCXRegIOper( );
  case EDXREGI:
    return new (C) eDXRegIOper( );
  case EDIREGI:
    return new (C) eDIRegIOper( );
  case NAXREGI:
    return new (C) naxRegIOper( );
  case NADXREGI:
    return new (C) nadxRegIOper( );
  case NCXREGI:
    return new (C) ncxRegIOper( );
  case ESIREGI:
    return new (C) eSIRegIOper( );
  case ANYREGP:
    return new (C) anyRegPOper( );
  case EREGP:
    return new (C) eRegPOper( );
  case EREGP_NO_EBP:
    return new (C) eRegP_no_EBPOper( );
  case NAXREGP:
    return new (C) naxRegPOper( );
  case NABXREGP:
    return new (C) nabxRegPOper( );
  case PREGP:
    return new (C) pRegPOper( );
  case EAXREGP:
    return new (C) eAXRegPOper( );
  case EBXREGP:
    return new (C) eBXRegPOper( );
  case ECXREGP:
    return new (C) eCXRegPOper( );
  case ESIREGP:
    return new (C) eSIRegPOper( );
  case EDIREGP:
    return new (C) eDIRegPOper( );
  case EREGL:
    return new (C) eRegLOper( );
  case EADXREGL:
    return new (C) eADXRegLOper( );
  case EBCXREGL:
    return new (C) eBCXRegLOper( );
  case EADXREGL_LOW_ONLY:
    return new (C) eADXRegL_low_onlyOper( );
  case EFLAGSREG:
    return new (C) eFlagsRegOper( );
  case EFLAGSREGU:
    return new (C) eFlagsRegUOper( );
  case EFLAGSREGUCF:
    return new (C) eFlagsRegUCFOper( );
  case FLAGSREG_LONG_LTGE:
    return new (C) flagsReg_long_LTGEOper( );
  case FLAGSREG_LONG_EQNE:
    return new (C) flagsReg_long_EQNEOper( );
  case FLAGSREG_LONG_LEGT:
    return new (C) flagsReg_long_LEGTOper( );
  case FLAGSREG_ULONG_LTGE:
    return new (C) flagsReg_ulong_LTGEOper( );
  case FLAGSREG_ULONG_EQNE:
    return new (C) flagsReg_ulong_EQNEOper( );
  case FLAGSREG_ULONG_LEGT:
    return new (C) flagsReg_ulong_LEGTOper( );
  case REGDPR:
    return new (C) regDPROper( );
  case REGDPR1:
    return new (C) regDPR1Oper( );
  case REGDPR2:
    return new (C) regDPR2Oper( );
  case REGNOTDPR1:
    return new (C) regnotDPR1Oper( );
  case REGFPR:
    return new (C) regFPROper( );
  case REGFPR1:
    return new (C) regFPR1Oper( );
  case REGF:
    return new (C) regFOper( );
  case REGD:
    return new (C) regDOper( );
  case DIRECT:
    return new (C) directOper(_leaf->bottom_type()->is_ptr() );
  case INDIRECT:
    return new (C) indirectOper( );
  case INDOFFSET8:
    return new (C) indOffset8Oper(_kids[1]->_leaf->get_int() );
  case INDOFFSET32:
    return new (C) indOffset32Oper(_kids[1]->_leaf->get_int() );
  case INDOFFSET32X:
    return new (C) indOffset32XOper(_kids[0]->_leaf->bottom_type()->is_ptr() );
  case INDINDEXOFFSET:
    return new (C) indIndexOffsetOper(_kids[1]->_leaf->get_int() );
  case INDINDEX:
    return new (C) indIndexOper( );
  case INDINDEXSCALE:
    return new (C) indIndexScaleOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case INDINDEXSCALEOFFSET:
    return new (C) indIndexScaleOffsetOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_int() );
  case LOAD_LONG_REGP:
    return new (C) load_long_RegPOper( );
  case LOAD_LONG_INDIRECT:
    return new (C) load_long_indirectOper( );
  case LOAD_LONG_INDOFFSET32:
    return new (C) load_long_indOffset32Oper(_kids[1]->_leaf->get_int() );
  case STACKSLOTP:
    return new (C) stackSlotPOper( );
  case STACKSLOTI:
    return new (C) stackSlotIOper( );
  case STACKSLOTF:
    return new (C) stackSlotFOper( );
  case STACKSLOTD:
    return new (C) stackSlotDOper( );
  case STACKSLOTL:
    return new (C) stackSlotLOper( );
  case INDIRECT_WIN95_SAFE:
    return new (C) indirect_win95_safeOper( );
  case INDOFFSET8_WIN95_SAFE:
    return new (C) indOffset8_win95_safeOper(_kids[1]->_leaf->get_int() );
  case INDOFFSET32_WIN95_SAFE:
    return new (C) indOffset32_win95_safeOper(_kids[1]->_leaf->get_int() );
  case INDINDEXOFFSET_WIN95_SAFE:
    return new (C) indIndexOffset_win95_safeOper(_kids[1]->_leaf->get_int() );
  case INDINDEXSCALE_WIN95_SAFE:
    return new (C) indIndexScale_win95_safeOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case INDINDEXSCALEOFFSET_WIN95_SAFE:
    return new (C) indIndexScaleOffset_win95_safeOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_int() );
  case CMPOP:
    return new (C) cmpOpOper(_leaf->as_Bool()->_test._test );
  case CMPOPU:
    return new (C) cmpOpUOper(_leaf->as_Bool()->_test._test );
  case CMPOPUCF:
    return new (C) cmpOpUCFOper(_leaf->as_Bool()->_test._test );
  case CMPOPUCF2:
    return new (C) cmpOpUCF2Oper(_leaf->as_Bool()->_test._test );
  case CMPOP_FCMOV:
    return new (C) cmpOp_fcmovOper(_leaf->as_Bool()->_test._test );
  case CMPOP_COMMUTE:
    return new (C) cmpOp_commuteOper(_leaf->as_Bool()->_test._test );
  case CMPOPU_COMMUTE:
    return new (C) cmpOpU_commuteOper(_leaf->as_Bool()->_test._test );
  case VECS:
    return new (C) vecSOper( );
  case VECD:
    return new (C) vecDOper( );
  case VECX:
    return new (C) vecXOper( );
  case VECY:
    return new (C) vecYOper( );
  case _ADDP_EREGP_RREGI:    return NULL;
  case _LSHIFTI_RREGI_IMMI2:    return NULL;
  case _ADDP_EREGP__LSHIFTI_RREGI_IMMI2:    return NULL;
  case _ADDP_EREGP_NO_EBP_RREGI:    return NULL;
  case _ADDP_EREGP_NO_EBP__LSHIFTI_RREGI_IMMI2:    return NULL;
  case _LOADI_MEMORY_:    return NULL;
  case _LOADL_MEMORY_:    return NULL;
  case _LOADB_MEMORY_:    return NULL;
  case _LOADUB_MEMORY_:    return NULL;
  case _ANDI__LOADUB_MEMORY__IMMI8:    return NULL;
  case _LOADS_MEMORY_:    return NULL;
  case _LSHIFTI__LOADS_MEMORY__IMMI_24:    return NULL;
  case _LOADUS_MEMORY_:    return NULL;
  case _LSHIFTI__LOADUS_MEMORY__IMMI_24:    return NULL;
  case _ANDI__LOADUS_MEMORY__IMMI_255:    return NULL;
  case _ANDI__LOADUS_MEMORY__IMMI16:    return NULL;
  case _LSHIFTI__LOADI_MEMORY__IMMI_24:    return NULL;
  case _LSHIFTI__LOADI_MEMORY__IMMI_16:    return NULL;
  case _ANDI__LOADI_MEMORY__IMMI_255:    return NULL;
  case _ANDI__LOADI_MEMORY__IMMI_65535:    return NULL;
  case _ANDI__LOADI_MEMORY__IMMU31:    return NULL;
  case _CONVI2L__LOADI_MEMORY__:    return NULL;
  case _CONVL2I_EREGL_:    return NULL;
  case _ROUNDDOUBLE_REGDPR1_:    return NULL;
  case _ROUNDFLOAT_REGFPR1_:    return NULL;
  case _CONVD2F_REGDPR1_:    return NULL;
  case _BINARY_CMPOP_EFLAGSREG:    return NULL;
  case _BINARY_RREGI_RREGI:    return NULL;
  case _BINARY_CMPOPU_EFLAGSREGU:    return NULL;
  case _BINARY_CMPOPUCF_EFLAGSREGUCF:    return NULL;
  case _BINARY_RREGI__LOADI_MEMORY_:    return NULL;
  case _BINARY_EREGP_EREGP:    return NULL;
  case _BINARY_CMPOP_FCMOV_EFLAGSREGU:    return NULL;
  case _BINARY_REGDPR1_REGDPR:    return NULL;
  case _BINARY_REGFPR1_REGFPR:    return NULL;
  case _BINARY_REGDPR_REGDPR:    return NULL;
  case _BINARY_REGFPR_REGFPR:    return NULL;
  case _BINARY_REGF_REGF:    return NULL;
  case _BINARY_REGD_REGD:    return NULL;
  case _BINARY_EREGL_EREGL:    return NULL;
  case _ADDI__LOADI_MEMORY__RREGI:    return NULL;
  case _ADDI_RREGI__LOADI_MEMORY_:    return NULL;
  case _ADDI__LOADI_MEMORY__IMMI:    return NULL;
  case _ADDI__LOADI_MEMORY__IMMI1:    return NULL;
  case _ADDI__LOADI_MEMORY__IMMI_M1:    return NULL;
  case _BINARY_EAXREGP_EREGP:    return NULL;
  case _BINARY_EAXREGI_RREGI:    return NULL;
  case _BINARY_EADXREGL_EBCXREGL:    return NULL;
  case _BINARY_EAXREGP_ECXREGP:    return NULL;
  case _BINARY_EAXREGI_ECXREGI:    return NULL;
  case _SUBI__LOADI_MEMORY__RREGI:    return NULL;
  case _SUBI_IMMI0_RREGI:    return NULL;
  case _CONVI2L_NADXREGI_:    return NULL;
  case _MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY:    return NULL;
  case _RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32:    return NULL;
  case _MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_:    return NULL;
  case _RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32:    return NULL;
  case _RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32_63:    return NULL;
  case _RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32_63:    return NULL;
  case _CONVI2L_EAXREGI_:    return NULL;
  case _ANDL__CONVI2L_EAXREGI__IMML_32BITS:    return NULL;
  case _ANDL__CONVI2L_NADXREGI__IMML_32BITS:    return NULL;
  case _RSHIFTI__LOADI_MEMORY__IMMI1:    return NULL;
  case _RSHIFTI__LOADI_MEMORY__IMMI8:    return NULL;
  case _LSHIFTI_XREGI_IMMI_24:    return NULL;
  case _LSHIFTI_XREGI_IMMI_16:    return NULL;
  case _ANDI__LOADI_MEMORY__RREGI:    return NULL;
  case _ANDI_RREGI__LOADI_MEMORY_:    return NULL;
  case _ANDI__LOADI_MEMORY__IMMI:    return NULL;
  case _XORI_RREGI_IMMI_M1:    return NULL;
  case _SUBI_IMMI0__LOADI_MEMORY_:    return NULL;
  case _ADDI_RREGI_IMMI_M1:    return NULL;
  case _CASTP2X_EREGP_:    return NULL;
  case _ORI__LOADI_MEMORY__RREGI:    return NULL;
  case _ORI_RREGI__LOADI_MEMORY_:    return NULL;
  case _ORI__LOADI_MEMORY__IMMI:    return NULL;
  case _LSHIFTI_RREGI_IMMI1:    return NULL;
  case _URSHIFTI_RREGI_IMMI_M1:    return NULL;
  case _LSHIFTI_RREGI_IMMI8:    return NULL;
  case _URSHIFTI_RREGI_IMMI8:    return NULL;
  case _LSHIFTI_NCXREGI_ECXREGI:    return NULL;
  case _SUBI_IMMI0_ECXREGI:    return NULL;
  case _URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI:    return NULL;
  case _SUBI_IMMI_32_ECXREGI:    return NULL;
  case _URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI:    return NULL;
  case _URSHIFTI_RREGI_IMMI1:    return NULL;
  case _LSHIFTI_RREGI_IMMI_M1:    return NULL;
  case _URSHIFTI_NCXREGI_ECXREGI:    return NULL;
  case _LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI:    return NULL;
  case _LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI:    return NULL;
  case _XORI__LOADI_MEMORY__RREGI:    return NULL;
  case _XORI_RREGI__LOADI_MEMORY_:    return NULL;
  case _XORI__LOADI_MEMORY__IMMI:    return NULL;
  case _CMPLTMASK_RREGI_RREGI:    return NULL;
  case _ANDI__CMPLTMASK_RREGI_RREGI_RREGI:    return NULL;
  case _SUBI_RREGI_RREGI:    return NULL;
  case _ANDI_RREGI__CMPLTMASK_RREGI_RREGI:    return NULL;
  case _LOADL_LOAD_LONG_MEMORY_:    return NULL;
  case _XORL_EREGL_IMML_M1:    return NULL;
  case _SUBL_IMML0_EREGL:    return NULL;
  case _SUBL_IMML0__LOADL_MEMORY_:    return NULL;
  case _ADDL_EREGL_IMML_M1:    return NULL;
  case _ADDL__LOADL_MEMORY__IMML_M1:    return NULL;
  case _LOADD_MEMORY_:    return NULL;
  case _SUBD_REGDPR_REGDPR:    return NULL;
  case _ADDD_REGDPR_REGDPR:    return NULL;
  case _ADDD__LOADD_MEMORY__REGDPR:    return NULL;
  case _ROUNDDOUBLE__ADDD__LOADD_MEMORY__REGDPR_:    return NULL;
  case _ADDD_REGDPR__LOADD_MEMORY_:    return NULL;
  case _ROUNDDOUBLE__ADDD_REGDPR__LOADD_MEMORY__:    return NULL;
  case _ADDD_REGDPR_IMMDPR:    return NULL;
  case _MULD_REGDPR_REGDPR:    return NULL;
  case _DIVD_REGDPR_REGDPR:    return NULL;
  case _LOADF_MEMORY_:    return NULL;
  case _MULF__LOADF_MEMORY__REGFPR:    return NULL;
  case _MULF_REGFPR__LOADF_MEMORY_:    return NULL;
  case _MULF_REGFPR_REGFPR:    return NULL;
  case _SUBF_REGFPR_REGFPR:    return NULL;
  case _CONVI2L_RREGI_:    return NULL;
  case _BINARY_EDIREGP_ECXREGI:    return NULL;
  case _BINARY_ESIREGP_EDXREGI:    return NULL;
  case _BINARY_EDIREGP_ESIREGP:    return NULL;
  case _BINARY_EDIREGP_EDXREGI:    return NULL;
  case _BINARY_ESIREGP_IMMI:    return NULL;
  case _BINARY_ESIREGP_EAXREGI:    return NULL;
  case _ANDI_RREGI_IMMI:    return NULL;
  case _ANDI_RREGI_MEMORY:    return NULL;
  case _LOADP_MEMORY_:    return NULL;
  case _BINARY_NADXREGI_EAXREGI:    return NULL;
  case _PARTIALSUBTYPECHECK_ESIREGP_EAXREGP:    return NULL;
  case _BINARY_CMPOP_FLAGSREG_LONG_LTGE:    return NULL;
  case _BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_:    return NULL;
  case _BINARY_CMPOP_FLAGSREG_LONG_EQNE:    return NULL;
  case _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT:    return NULL;
  case _CONVF2D_REGF_:    return NULL;
  case _SQRTD__CONVF2D_REGF__:    return NULL;
  case _CONVF2D__LOADF_MEMORY__:    return NULL;
  case _SQRTD__CONVF2D__LOADF_MEMORY___:    return NULL;
  case _CONVF2D_IMMF_:    return NULL;
  case _SQRTD__CONVF2D_IMMF__:    return NULL;
  case _LOADVECTOR_MEMORY_:    return NULL;
  
  default:
    fprintf(stderr, "Default MachOper Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  }
  return NULL;
};


//------------------------- MachNode Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachNode *State::MachNodeGenerator(int opcode, Compile* C){
  switch(opcode) {
  case bytes_reverse_int_rule: {
      bytes_reverse_intNode *node = new (C) bytes_reverse_intNode();
      return node;
    }
  case bytes_reverse_long_rule: {
      bytes_reverse_longNode *node = new (C) bytes_reverse_longNode();
      return node;
    }
  case bytes_reverse_unsigned_short_rule: {
      bytes_reverse_unsigned_shortNode *node = new (C) bytes_reverse_unsigned_shortNode();
      return node;
    }
  case bytes_reverse_short_rule: {
      bytes_reverse_shortNode *node = new (C) bytes_reverse_shortNode();
      return node;
    }
  case countLeadingZerosI_rule: {
      countLeadingZerosINode *node = new (C) countLeadingZerosINode();
      return node;
    }
  case countLeadingZerosI_bsr_rule: {
      countLeadingZerosI_bsrNode *node = new (C) countLeadingZerosI_bsrNode();
      return node;
    }
  case countLeadingZerosL_rule: {
      countLeadingZerosLNode *node = new (C) countLeadingZerosLNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI, C));
      return node;
    }
  case countLeadingZerosL_bsr_rule: {
      countLeadingZerosL_bsrNode *node = new (C) countLeadingZerosL_bsrNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI, C));
      return node;
    }
  case countTrailingZerosI_rule: {
      countTrailingZerosINode *node = new (C) countTrailingZerosINode();
      return node;
    }
  case countTrailingZerosI_bsf_rule: {
      countTrailingZerosI_bsfNode *node = new (C) countTrailingZerosI_bsfNode();
      return node;
    }
  case countTrailingZerosL_rule: {
      countTrailingZerosLNode *node = new (C) countTrailingZerosLNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI, C));
      return node;
    }
  case countTrailingZerosL_bsf_rule: {
      countTrailingZerosL_bsfNode *node = new (C) countTrailingZerosL_bsfNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI, C));
      return node;
    }
  case popCountI_rule: {
      popCountINode *node = new (C) popCountINode();
      return node;
    }
  case popCountI_mem_rule: {
      popCountI_memNode *node = new (C) popCountI_memNode();
      return node;
    }
  case popCountL_rule: {
      popCountLNode *node = new (C) popCountLNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI, C));
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case popCountL_mem_rule: {
      popCountL_memNode *node = new (C) popCountL_memNode();
      node->set_opnd_array(2, MachOperGenerator(RREGI, C));
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case loadB_rule: {
      loadBNode *node = new (C) loadBNode();
      return node;
    }
  case loadB2L_rule: {
      loadB2LNode *node = new (C) loadB2LNode();
      return node;
    }
  case loadUB_rule: {
      loadUBNode *node = new (C) loadUBNode();
      return node;
    }
  case loadUB2L_rule: {
      loadUB2LNode *node = new (C) loadUB2LNode();
      return node;
    }
  case loadUB2L_immI8_rule: {
      loadUB2L_immI8Node *node = new (C) loadUB2L_immI8Node();
      return node;
    }
  case loadS_rule: {
      loadSNode *node = new (C) loadSNode();
      return node;
    }
  case loadS2B_rule: {
      loadS2BNode *node = new (C) loadS2BNode();
      return node;
    }
  case loadS2L_rule: {
      loadS2LNode *node = new (C) loadS2LNode();
      return node;
    }
  case loadUS_rule: {
      loadUSNode *node = new (C) loadUSNode();
      return node;
    }
  case loadUS2B_rule: {
      loadUS2BNode *node = new (C) loadUS2BNode();
      return node;
    }
  case loadUS2L_rule: {
      loadUS2LNode *node = new (C) loadUS2LNode();
      return node;
    }
  case loadUS2L_immI_255_rule: {
      loadUS2L_immI_255Node *node = new (C) loadUS2L_immI_255Node();
      return node;
    }
  case loadUS2L_immI16_rule: {
      loadUS2L_immI16Node *node = new (C) loadUS2L_immI16Node();
      return node;
    }
  case loadI_rule: {
      loadINode *node = new (C) loadINode();
      return node;
    }
  case loadI2B_rule: {
      loadI2BNode *node = new (C) loadI2BNode();
      return node;
    }
  case loadI2UB_rule: {
      loadI2UBNode *node = new (C) loadI2UBNode();
      return node;
    }
  case loadI2S_rule: {
      loadI2SNode *node = new (C) loadI2SNode();
      return node;
    }
  case loadI2US_rule: {
      loadI2USNode *node = new (C) loadI2USNode();
      return node;
    }
  case loadI2L_rule: {
      loadI2LNode *node = new (C) loadI2LNode();
      return node;
    }
  case loadI2L_immI_255_rule: {
      loadI2L_immI_255Node *node = new (C) loadI2L_immI_255Node();
      return node;
    }
  case loadI2L_immI_65535_rule: {
      loadI2L_immI_65535Node *node = new (C) loadI2L_immI_65535Node();
      return node;
    }
  case loadI2L_immU31_rule: {
      loadI2L_immU31Node *node = new (C) loadI2L_immU31Node();
      return node;
    }
  case loadUI2L_rule: {
      loadUI2LNode *node = new (C) loadUI2LNode();
      return node;
    }
  case loadL_rule: {
      loadLNode *node = new (C) loadLNode();
      return node;
    }
  case loadL_volatile_rule: {
      loadL_volatileNode *node = new (C) loadL_volatileNode();
      return node;
    }
  case loadLX_volatile_rule: {
      loadLX_volatileNode *node = new (C) loadLX_volatileNode();
      node->set_opnd_array(2, MachOperGenerator(REGD, C));
      return node;
    }
  case loadLX_reg_volatile_rule: {
      loadLX_reg_volatileNode *node = new (C) loadLX_reg_volatileNode();
      node->set_opnd_array(2, MachOperGenerator(REGD, C));
      return node;
    }
  case loadRange_rule: {
      loadRangeNode *node = new (C) loadRangeNode();
      return node;
    }
  case loadP_rule: {
      loadPNode *node = new (C) loadPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadKlass_rule: {
      loadKlassNode *node = new (C) loadKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadDPR_rule: {
      loadDPRNode *node = new (C) loadDPRNode();
      return node;
    }
  case loadD_rule: {
      loadDNode *node = new (C) loadDNode();
      return node;
    }
  case loadD_partial_rule: {
      loadD_partialNode *node = new (C) loadD_partialNode();
      return node;
    }
  case loadF_rule: {
      loadFNode *node = new (C) loadFNode();
      return node;
    }
  case loadFPR_rule: {
      loadFPRNode *node = new (C) loadFPRNode();
      return node;
    }
  case leaP8_rule: {
      leaP8Node *node = new (C) leaP8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case leaP32_rule: {
      leaP32Node *node = new (C) leaP32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case leaPIdxOff_rule: {
      leaPIdxOffNode *node = new (C) leaPIdxOffNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case leaPIdxScale_rule: {
      leaPIdxScaleNode *node = new (C) leaPIdxScaleNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case leaPIdxScaleOff_rule: {
      leaPIdxScaleOffNode *node = new (C) leaPIdxScaleOffNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConI_rule: {
      loadConINode *node = new (C) loadConINode();
      node->_opnd_array[1] = new (C) immIOper(_leaf->get_int() );
      return node;
    }
  case loadConI0_rule: {
      loadConI0Node *node = new (C) loadConI0Node();
      return node;
    }
  case loadConP_rule: {
      loadConPNode *node = new (C) loadConPNode();
      node->_opnd_array[1] = new (C) immPOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConL_rule: {
      loadConLNode *node = new (C) loadConLNode();
      return node;
    }
  case loadConL0_rule: {
      loadConL0Node *node = new (C) loadConL0Node();
      return node;
    }
  case loadConFPR_rule: {
      loadConFPRNode *node = new (C) loadConFPRNode();
      node->_opnd_array[1] = new (C) immFPROper(_leaf->getf() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConFPR0_rule: {
      loadConFPR0Node *node = new (C) loadConFPR0Node();
      node->_opnd_array[1] = new (C) immFPR0Oper(_leaf->getf() );
      return node;
    }
  case loadConFPR1_rule: {
      loadConFPR1Node *node = new (C) loadConFPR1Node();
      node->_opnd_array[1] = new (C) immFPR1Oper(_leaf->getf() );
      return node;
    }
  case loadConF_rule: {
      loadConFNode *node = new (C) loadConFNode();
      node->_opnd_array[1] = new (C) immFOper(_leaf->getf() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConF0_rule: {
      loadConF0Node *node = new (C) loadConF0Node();
      node->_opnd_array[1] = new (C) immF0Oper(_leaf->getf() );
      return node;
    }
  case loadConDPR_rule: {
      loadConDPRNode *node = new (C) loadConDPRNode();
      node->_opnd_array[1] = new (C) immDPROper(_leaf->getd() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConDPR0_rule: {
      loadConDPR0Node *node = new (C) loadConDPR0Node();
      node->_opnd_array[1] = new (C) immDPR0Oper(_leaf->getd() );
      return node;
    }
  case loadConDPR1_rule: {
      loadConDPR1Node *node = new (C) loadConDPR1Node();
      node->_opnd_array[1] = new (C) immDPR1Oper(_leaf->getd() );
      return node;
    }
  case loadConD_rule: {
      loadConDNode *node = new (C) loadConDNode();
      node->_opnd_array[1] = new (C) immDOper(_leaf->getd() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConD0_rule: {
      loadConD0Node *node = new (C) loadConD0Node();
      node->_opnd_array[1] = new (C) immD0Oper(_leaf->getd() );
      return node;
    }
  case loadSSI_rule: {
      loadSSINode *node = new (C) loadSSINode();
      return node;
    }
  case loadSSL_rule: {
      loadSSLNode *node = new (C) loadSSLNode();
      return node;
    }
  case loadSSP_rule: {
      loadSSPNode *node = new (C) loadSSPNode();
      return node;
    }
  case loadSSF_rule: {
      loadSSFNode *node = new (C) loadSSFNode();
      return node;
    }
  case loadSSD_rule: {
      loadSSDNode *node = new (C) loadSSDNode();
      return node;
    }
  case prefetchr0_rule: {
      prefetchr0Node *node = new (C) prefetchr0Node();
      return node;
    }
  case prefetchr_rule: {
      prefetchrNode *node = new (C) prefetchrNode();
      return node;
    }
  case prefetchrNTA_rule: {
      prefetchrNTANode *node = new (C) prefetchrNTANode();
      return node;
    }
  case prefetchrT0_rule: {
      prefetchrT0Node *node = new (C) prefetchrT0Node();
      return node;
    }
  case prefetchrT2_rule: {
      prefetchrT2Node *node = new (C) prefetchrT2Node();
      return node;
    }
  case prefetchw0_rule: {
      prefetchw0Node *node = new (C) prefetchw0Node();
      return node;
    }
  case prefetchw_rule: {
      prefetchwNode *node = new (C) prefetchwNode();
      return node;
    }
  case prefetchwNTA_rule: {
      prefetchwNTANode *node = new (C) prefetchwNTANode();
      return node;
    }
  case prefetchAlloc0_rule: {
      prefetchAlloc0Node *node = new (C) prefetchAlloc0Node();
      return node;
    }
  case prefetchAlloc_rule: {
      prefetchAllocNode *node = new (C) prefetchAllocNode();
      return node;
    }
  case prefetchAllocNTA_rule: {
      prefetchAllocNTANode *node = new (C) prefetchAllocNTANode();
      return node;
    }
  case prefetchAllocT0_rule: {
      prefetchAllocT0Node *node = new (C) prefetchAllocT0Node();
      return node;
    }
  case prefetchAllocT2_rule: {
      prefetchAllocT2Node *node = new (C) prefetchAllocT2Node();
      return node;
    }
  case storeB_rule: {
      storeBNode *node = new (C) storeBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeC_rule: {
      storeCNode *node = new (C) storeCNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_rule: {
      storeINode *node = new (C) storeINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_rule: {
      storeLNode *node = new (C) storeLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL2I_rule: {
      storeL2INode *node = new (C) storeL2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_volatile_rule: {
      storeL_volatileNode *node = new (C) storeL_volatileNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeLX_volatile_rule: {
      storeLX_volatileNode *node = new (C) storeLX_volatileNode();
      node->set_opnd_array(3, MachOperGenerator(REGD, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeLX_reg_volatile_rule: {
      storeLX_reg_volatileNode *node = new (C) storeLX_reg_volatileNode();
      node->set_opnd_array(3, MachOperGenerator(REGD, C));
      node->set_opnd_array(4, MachOperGenerator(REGD, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP_rule: {
      storePNode *node = new (C) storePNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmI_rule: {
      storeImmINode *node = new (C) storeImmINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmI16_rule: {
      storeImmI16Node *node = new (C) storeImmI16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmP_rule: {
      storeImmPNode *node = new (C) storeImmPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmB_rule: {
      storeImmBNode *node = new (C) storeImmBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmCM_rule: {
      storeImmCMNode *node = new (C) storeImmCMNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeDPR_rule: {
      storeDPRNode *node = new (C) storeDPRNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeDPR_rounded_rule: {
      storeDPR_roundedNode *node = new (C) storeDPR_roundedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeD_rule: {
      storeDNode *node = new (C) storeDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_rule: {
      storeFNode *node = new (C) storeFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeFPR_rule: {
      storeFPRNode *node = new (C) storeFPRNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeFPR_rounded_rule: {
      storeFPR_roundedNode *node = new (C) storeFPR_roundedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeFPR_Drounded_rule: {
      storeFPR_DroundedNode *node = new (C) storeFPR_DroundedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeFPR_imm_rule: {
      storeFPR_immNode *node = new (C) storeFPR_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_imm_rule: {
      storeF_immNode *node = new (C) storeF_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeSSI_rule: {
      storeSSINode *node = new (C) storeSSINode();
      return node;
    }
  case storeSSP_rule: {
      storeSSPNode *node = new (C) storeSSPNode();
      return node;
    }
  case storeSSL_rule: {
      storeSSLNode *node = new (C) storeSSLNode();
      return node;
    }
  case membar_acquire_rule: {
      membar_acquireNode *node = new (C) membar_acquireNode();
      return node;
    }
  case membar_acquire_0_rule: {
      membar_acquire_0Node *node = new (C) membar_acquire_0Node();
      return node;
    }
  case membar_acquire_lock_rule: {
      membar_acquire_lockNode *node = new (C) membar_acquire_lockNode();
      return node;
    }
  case membar_release_rule: {
      membar_releaseNode *node = new (C) membar_releaseNode();
      return node;
    }
  case membar_release_0_rule: {
      membar_release_0Node *node = new (C) membar_release_0Node();
      return node;
    }
  case membar_release_lock_rule: {
      membar_release_lockNode *node = new (C) membar_release_lockNode();
      return node;
    }
  case membar_volatile_rule: {
      membar_volatileNode *node = new (C) membar_volatileNode();
      node->set_opnd_array(1, MachOperGenerator(EFLAGSREG, C));
      return node;
    }
  case unnecessary_membar_volatile_rule: {
      unnecessary_membar_volatileNode *node = new (C) unnecessary_membar_volatileNode();
      return node;
    }
  case membar_storestore_rule: {
      membar_storestoreNode *node = new (C) membar_storestoreNode();
      return node;
    }
  case castX2P_rule: {
      castX2PNode *node = new (C) castX2PNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castP2X_rule: {
      castP2XNode *node = new (C) castP2XNode();
      return node;
    }
  case jmovI_reg_rule: {
      jmovI_regNode *node = new (C) jmovI_regNode();
      return node;
    }
  case jmovI_regU_rule: {
      jmovI_regUNode *node = new (C) jmovI_regUNode();
      return node;
    }
  case cmovI_reg_rule: {
      cmovI_regNode *node = new (C) cmovI_regNode();
      return node;
    }
  case cmovI_regU_rule: {
      cmovI_regUNode *node = new (C) cmovI_regUNode();
      return node;
    }
  case cmovI_regUCF_rule: {
      cmovI_regUCFNode *node = new (C) cmovI_regUCFNode();
      return node;
    }
  case cmovI_mem_rule: {
      cmovI_memNode *node = new (C) cmovI_memNode();
      return node;
    }
  case cmovI_memU_rule: {
      cmovI_memUNode *node = new (C) cmovI_memUNode();
      return node;
    }
  case cmovI_memUCF_rule: {
      cmovI_memUCFNode *node = new (C) cmovI_memUCFNode();
      return node;
    }
  case cmovP_reg_rule: {
      cmovP_regNode *node = new (C) cmovP_regNode();
      return node;
    }
  case cmovP_reg_nonP6_rule: {
      cmovP_reg_nonP6Node *node = new (C) cmovP_reg_nonP6Node();
      return node;
    }
  case cmovP_regU_rule: {
      cmovP_regUNode *node = new (C) cmovP_regUNode();
      return node;
    }
  case cmovP_regUCF_rule: {
      cmovP_regUCFNode *node = new (C) cmovP_regUCFNode();
      return node;
    }
  case fcmovDPR_regU_rule: {
      fcmovDPR_regUNode *node = new (C) fcmovDPR_regUNode();
      return node;
    }
  case fcmovFPR_regU_rule: {
      fcmovFPR_regUNode *node = new (C) fcmovFPR_regUNode();
      return node;
    }
  case fcmovDPR_regS_rule: {
      fcmovDPR_regSNode *node = new (C) fcmovDPR_regSNode();
      return node;
    }
  case fcmovFPR_regS_rule: {
      fcmovFPR_regSNode *node = new (C) fcmovFPR_regSNode();
      return node;
    }
  case fcmovF_regS_rule: {
      fcmovF_regSNode *node = new (C) fcmovF_regSNode();
      return node;
    }
  case fcmovD_regS_rule: {
      fcmovD_regSNode *node = new (C) fcmovD_regSNode();
      return node;
    }
  case fcmovF_regU_rule: {
      fcmovF_regUNode *node = new (C) fcmovF_regUNode();
      return node;
    }
  case fcmovF_regUCF_rule: {
      fcmovF_regUCFNode *node = new (C) fcmovF_regUCFNode();
      return node;
    }
  case fcmovD_regU_rule: {
      fcmovD_regUNode *node = new (C) fcmovD_regUNode();
      return node;
    }
  case fcmovD_regUCF_rule: {
      fcmovD_regUCFNode *node = new (C) fcmovD_regUCFNode();
      return node;
    }
  case cmovL_reg_rule: {
      cmovL_regNode *node = new (C) cmovL_regNode();
      return node;
    }
  case cmovL_regU_rule: {
      cmovL_regUNode *node = new (C) cmovL_regUNode();
      return node;
    }
  case cmovL_regUCF_rule: {
      cmovL_regUCFNode *node = new (C) cmovL_regUCFNode();
      return node;
    }
  case addI_eReg_rule: {
      addI_eRegNode *node = new (C) addI_eRegNode();
      return node;
    }
  case addI_eReg_imm_rule: {
      addI_eReg_immNode *node = new (C) addI_eReg_immNode();
      return node;
    }
  case incI_eReg_rule: {
      incI_eRegNode *node = new (C) incI_eRegNode();
      return node;
    }
  case leaI_eReg_immI_rule: {
      leaI_eReg_immINode *node = new (C) leaI_eReg_immINode();
      return node;
    }
  case leaP_eReg_immI_rule: {
      leaP_eReg_immINode *node = new (C) leaP_eReg_immINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decI_eReg_rule: {
      decI_eRegNode *node = new (C) decI_eRegNode();
      return node;
    }
  case addP_eReg_rule: {
      addP_eRegNode *node = new (C) addP_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_eReg_imm_rule: {
      addP_eReg_immNode *node = new (C) addP_eReg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addI_eReg_mem_rule: {
      addI_eReg_memNode *node = new (C) addI_eReg_memNode();
      return node;
    }
  case addI_eReg_mem_0_rule: {
      addI_eReg_mem_0Node *node = new (C) addI_eReg_mem_0Node();
      return node;
    }
  case addI_mem_eReg_rule: {
      addI_mem_eRegNode *node = new (C) addI_mem_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addI_mem_eReg_0_rule: {
      addI_mem_eReg_0Node *node = new (C) addI_mem_eReg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addI_mem_imm_rule: {
      addI_mem_immNode *node = new (C) addI_mem_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case incI_mem_rule: {
      incI_memNode *node = new (C) incI_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decI_mem_rule: {
      decI_memNode *node = new (C) decI_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case checkCastPP_rule: {
      checkCastPPNode *node = new (C) checkCastPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castPP_rule: {
      castPPNode *node = new (C) castPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castII_rule: {
      castIINode *node = new (C) castIINode();
      return node;
    }
  case loadPLocked_rule: {
      loadPLockedNode *node = new (C) loadPLockedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storePConditional_rule: {
      storePConditionalNode *node = new (C) storePConditionalNode();
      return node;
    }
  case storeIConditional_rule: {
      storeIConditionalNode *node = new (C) storeIConditionalNode();
      return node;
    }
  case storeLConditional_rule: {
      storeLConditionalNode *node = new (C) storeLConditionalNode();
      return node;
    }
  case compareAndSwapL_rule: {
      compareAndSwapLNode *node = new (C) compareAndSwapLNode();
      return node;
    }
  case compareAndSwapP_rule: {
      compareAndSwapPNode *node = new (C) compareAndSwapPNode();
      return node;
    }
  case compareAndSwapI_rule: {
      compareAndSwapINode *node = new (C) compareAndSwapINode();
      return node;
    }
  case xaddI_no_res_rule: {
      xaddI_no_resNode *node = new (C) xaddI_no_resNode();
      return node;
    }
  case xaddI_rule: {
      xaddINode *node = new (C) xaddINode();
      return node;
    }
  case xchgI_rule: {
      xchgINode *node = new (C) xchgINode();
      return node;
    }
  case xchgP_rule: {
      xchgPNode *node = new (C) xchgPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subI_eReg_rule: {
      subI_eRegNode *node = new (C) subI_eRegNode();
      return node;
    }
  case subI_eReg_imm_rule: {
      subI_eReg_immNode *node = new (C) subI_eReg_immNode();
      return node;
    }
  case subI_eReg_mem_rule: {
      subI_eReg_memNode *node = new (C) subI_eReg_memNode();
      return node;
    }
  case subI_mem_eReg_rule: {
      subI_mem_eRegNode *node = new (C) subI_mem_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subP_eReg_rule: {
      subP_eRegNode *node = new (C) subP_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case negI_eReg_rule: {
      negI_eRegNode *node = new (C) negI_eRegNode();
      return node;
    }
  case mulI_eReg_rule: {
      mulI_eRegNode *node = new (C) mulI_eRegNode();
      return node;
    }
  case mulI_eReg_imm_rule: {
      mulI_eReg_immNode *node = new (C) mulI_eReg_immNode();
      return node;
    }
  case loadConL_low_only_rule: {
      loadConL_low_onlyNode *node = new (C) loadConL_low_onlyNode();
      return node;
    }
  case mulI_imm_high_rule: {
      mulI_imm_highNode *node = new (C) mulI_imm_highNode();
      return node;
    }
  case mulI_imm_high_0_rule: {
      mulI_imm_high_0Node *node = new (C) mulI_imm_high_0Node();
      return node;
    }
  case mulI_imm_RShift_high_rule: {
      mulI_imm_RShift_highNode *node = new (C) mulI_imm_RShift_highNode();
      return node;
    }
  case mulI_imm_RShift_high_0_rule: {
      mulI_imm_RShift_high_0Node *node = new (C) mulI_imm_RShift_high_0Node();
      return node;
    }
  case mulI_mem_imm_rule: {
      mulI_mem_immNode *node = new (C) mulI_mem_immNode();
      return node;
    }
  case mulI_rule: {
      mulINode *node = new (C) mulINode();
      return node;
    }
  case mulI_0_rule: {
      mulI_0Node *node = new (C) mulI_0Node();
      return node;
    }
  case mulI2L_rule: {
      mulI2LNode *node = new (C) mulI2LNode();
      return node;
    }
  case mulI2L_0_rule: {
      mulI2L_0Node *node = new (C) mulI2L_0Node();
      return node;
    }
  case mulIS_eReg_rule: {
      mulIS_eRegNode *node = new (C) mulIS_eRegNode();
      return node;
    }
  case mulIS_eReg_0_rule: {
      mulIS_eReg_0Node *node = new (C) mulIS_eReg_0Node();
      return node;
    }
  case mulL_eReg_rule: {
      mulL_eRegNode *node = new (C) mulL_eRegNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case mulL_eReg_lhi0_rule: {
      mulL_eReg_lhi0Node *node = new (C) mulL_eReg_lhi0Node();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case mulL_eReg_rhi0_rule: {
      mulL_eReg_rhi0Node *node = new (C) mulL_eReg_rhi0Node();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case mulL_eReg_hi0_rule: {
      mulL_eReg_hi0Node *node = new (C) mulL_eReg_hi0Node();
      return node;
    }
  case mulL_eReg_con_rule: {
      mulL_eReg_conNode *node = new (C) mulL_eReg_conNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case divI_eReg_rule: {
      divI_eRegNode *node = new (C) divI_eRegNode();
      return node;
    }
  case divL_eReg_rule: {
      divL_eRegNode *node = new (C) divL_eRegNode();
      return node;
    }
  case divModI_eReg_divmod_rule: {
      divModI_eReg_divmodNode *node = new (C) divModI_eReg_divmodNode();
      return node;
    }
  case modI_eReg_rule: {
      modI_eRegNode *node = new (C) modI_eRegNode();
      return node;
    }
  case modL_eReg_rule: {
      modL_eRegNode *node = new (C) modL_eRegNode();
      return node;
    }
  case divL_eReg_imm32_rule: {
      divL_eReg_imm32Node *node = new (C) divL_eReg_imm32Node();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      node->set_opnd_array(4, MachOperGenerator(RREGI, C));
      return node;
    }
  case modL_eReg_imm32_rule: {
      modL_eReg_imm32Node *node = new (C) modL_eReg_imm32Node();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      node->set_opnd_array(4, MachOperGenerator(RREGI, C));
      return node;
    }
  case shlI_eReg_1_rule: {
      shlI_eReg_1Node *node = new (C) shlI_eReg_1Node();
      return node;
    }
  case salI_eReg_imm_rule: {
      salI_eReg_immNode *node = new (C) salI_eReg_immNode();
      return node;
    }
  case salI_eReg_CL_rule: {
      salI_eReg_CLNode *node = new (C) salI_eReg_CLNode();
      return node;
    }
  case sarI_eReg_1_rule: {
      sarI_eReg_1Node *node = new (C) sarI_eReg_1Node();
      return node;
    }
  case sarI_mem_1_rule: {
      sarI_mem_1Node *node = new (C) sarI_mem_1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sarI_eReg_imm_rule: {
      sarI_eReg_immNode *node = new (C) sarI_eReg_immNode();
      return node;
    }
  case sarI_mem_imm_rule: {
      sarI_mem_immNode *node = new (C) sarI_mem_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sarI_eReg_CL_rule: {
      sarI_eReg_CLNode *node = new (C) sarI_eReg_CLNode();
      return node;
    }
  case shrI_eReg_1_rule: {
      shrI_eReg_1Node *node = new (C) shrI_eReg_1Node();
      return node;
    }
  case shrI_eReg_imm_rule: {
      shrI_eReg_immNode *node = new (C) shrI_eReg_immNode();
      return node;
    }
  case i2b_rule: {
      i2bNode *node = new (C) i2bNode();
      return node;
    }
  case i2s_rule: {
      i2sNode *node = new (C) i2sNode();
      return node;
    }
  case shrI_eReg_CL_rule: {
      shrI_eReg_CLNode *node = new (C) shrI_eReg_CLNode();
      return node;
    }
  case andI_eReg_rule: {
      andI_eRegNode *node = new (C) andI_eRegNode();
      return node;
    }
  case andI_eReg_imm_rule: {
      andI_eReg_immNode *node = new (C) andI_eReg_immNode();
      return node;
    }
  case andI_eReg_mem_rule: {
      andI_eReg_memNode *node = new (C) andI_eReg_memNode();
      return node;
    }
  case andI_eReg_mem_0_rule: {
      andI_eReg_mem_0Node *node = new (C) andI_eReg_mem_0Node();
      return node;
    }
  case andI_mem_eReg_rule: {
      andI_mem_eRegNode *node = new (C) andI_mem_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andI_mem_eReg_0_rule: {
      andI_mem_eReg_0Node *node = new (C) andI_mem_eReg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andI_mem_imm_rule: {
      andI_mem_immNode *node = new (C) andI_mem_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case andnI_rReg_rReg_rReg_rule: {
      andnI_rReg_rReg_rRegNode *node = new (C) andnI_rReg_rReg_rRegNode();
      return node;
    }
  case andnI_rReg_rReg_rReg_0_rule: {
      andnI_rReg_rReg_rReg_0Node *node = new (C) andnI_rReg_rReg_rReg_0Node();
      return node;
    }
  case andnI_rReg_rReg_mem_rule: {
      andnI_rReg_rReg_memNode *node = new (C) andnI_rReg_rReg_memNode();
      return node;
    }
  case andnI_rReg_rReg_mem_0_rule: {
      andnI_rReg_rReg_mem_0Node *node = new (C) andnI_rReg_rReg_mem_0Node();
      return node;
    }
  case blsiI_rReg_rReg_rule: {
      blsiI_rReg_rRegNode *node = new (C) blsiI_rReg_rRegNode();
      return node;
    }
  case blsiI_rReg_rReg_0_rule: {
      blsiI_rReg_rReg_0Node *node = new (C) blsiI_rReg_rReg_0Node();
      return node;
    }
  case blsiI_rReg_mem_rule: {
      blsiI_rReg_memNode *node = new (C) blsiI_rReg_memNode();
      return node;
    }
  case blsiI_rReg_mem_0_rule: {
      blsiI_rReg_mem_0Node *node = new (C) blsiI_rReg_mem_0Node();
      return node;
    }
  case blsmskI_rReg_rReg_rule: {
      blsmskI_rReg_rRegNode *node = new (C) blsmskI_rReg_rRegNode();
      return node;
    }
  case blsmskI_rReg_rReg_0_rule: {
      blsmskI_rReg_rReg_0Node *node = new (C) blsmskI_rReg_rReg_0Node();
      return node;
    }
  case blsmskI_rReg_mem_rule: {
      blsmskI_rReg_memNode *node = new (C) blsmskI_rReg_memNode();
      return node;
    }
  case blsmskI_rReg_mem_0_rule: {
      blsmskI_rReg_mem_0Node *node = new (C) blsmskI_rReg_mem_0Node();
      return node;
    }
  case blsrI_rReg_rReg_rule: {
      blsrI_rReg_rRegNode *node = new (C) blsrI_rReg_rRegNode();
      return node;
    }
  case blsrI_rReg_rReg_0_rule: {
      blsrI_rReg_rReg_0Node *node = new (C) blsrI_rReg_rReg_0Node();
      return node;
    }
  case blsrI_rReg_mem_rule: {
      blsrI_rReg_memNode *node = new (C) blsrI_rReg_memNode();
      return node;
    }
  case blsrI_rReg_mem_0_rule: {
      blsrI_rReg_mem_0Node *node = new (C) blsrI_rReg_mem_0Node();
      return node;
    }
  case orI_eReg_rule: {
      orI_eRegNode *node = new (C) orI_eRegNode();
      return node;
    }
  case orI_eReg_castP2X_rule: {
      orI_eReg_castP2XNode *node = new (C) orI_eReg_castP2XNode();
      return node;
    }
  case orI_eReg_castP2X_0_rule: {
      orI_eReg_castP2X_0Node *node = new (C) orI_eReg_castP2X_0Node();
      return node;
    }
  case orI_eReg_imm_rule: {
      orI_eReg_immNode *node = new (C) orI_eReg_immNode();
      return node;
    }
  case orI_eReg_mem_rule: {
      orI_eReg_memNode *node = new (C) orI_eReg_memNode();
      return node;
    }
  case orI_eReg_mem_0_rule: {
      orI_eReg_mem_0Node *node = new (C) orI_eReg_mem_0Node();
      return node;
    }
  case orI_mem_eReg_rule: {
      orI_mem_eRegNode *node = new (C) orI_mem_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case orI_mem_eReg_0_rule: {
      orI_mem_eReg_0Node *node = new (C) orI_mem_eReg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case orI_mem_imm_rule: {
      orI_mem_immNode *node = new (C) orI_mem_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rolI_eReg_i1_rule: {
      rolI_eReg_i1Node *node = new (C) rolI_eReg_i1Node();
      return node;
    }
  case rolI_eReg_i1_0_rule: {
      rolI_eReg_i1_0Node *node = new (C) rolI_eReg_i1_0Node();
      return node;
    }
  case rolI_eReg_i8_rule: {
      rolI_eReg_i8Node *node = new (C) rolI_eReg_i8Node();
      return node;
    }
  case rolI_eReg_i8_0_rule: {
      rolI_eReg_i8_0Node *node = new (C) rolI_eReg_i8_0Node();
      return node;
    }
  case rolI_eReg_Var_C0_rule: {
      rolI_eReg_Var_C0Node *node = new (C) rolI_eReg_Var_C0Node();
      return node;
    }
  case rolI_eReg_Var_C0_0_rule: {
      rolI_eReg_Var_C0_0Node *node = new (C) rolI_eReg_Var_C0_0Node();
      return node;
    }
  case rolI_eReg_Var_C32_rule: {
      rolI_eReg_Var_C32Node *node = new (C) rolI_eReg_Var_C32Node();
      return node;
    }
  case rolI_eReg_Var_C32_0_rule: {
      rolI_eReg_Var_C32_0Node *node = new (C) rolI_eReg_Var_C32_0Node();
      return node;
    }
  case rorI_eReg_i1_rule: {
      rorI_eReg_i1Node *node = new (C) rorI_eReg_i1Node();
      return node;
    }
  case rorI_eReg_i1_0_rule: {
      rorI_eReg_i1_0Node *node = new (C) rorI_eReg_i1_0Node();
      return node;
    }
  case rorI_eReg_i8_rule: {
      rorI_eReg_i8Node *node = new (C) rorI_eReg_i8Node();
      return node;
    }
  case rorI_eReg_i8_0_rule: {
      rorI_eReg_i8_0Node *node = new (C) rorI_eReg_i8_0Node();
      return node;
    }
  case rorI_eReg_Var_C0_rule: {
      rorI_eReg_Var_C0Node *node = new (C) rorI_eReg_Var_C0Node();
      return node;
    }
  case rorI_eReg_Var_C0_0_rule: {
      rorI_eReg_Var_C0_0Node *node = new (C) rorI_eReg_Var_C0_0Node();
      return node;
    }
  case rorI_eReg_Var_C32_rule: {
      rorI_eReg_Var_C32Node *node = new (C) rorI_eReg_Var_C32Node();
      return node;
    }
  case rorI_eReg_Var_C32_0_rule: {
      rorI_eReg_Var_C32_0Node *node = new (C) rorI_eReg_Var_C32_0Node();
      return node;
    }
  case xorI_eReg_rule: {
      xorI_eRegNode *node = new (C) xorI_eRegNode();
      return node;
    }
  case xorI_eReg_im1_rule: {
      xorI_eReg_im1Node *node = new (C) xorI_eReg_im1Node();
      return node;
    }
  case xorI_eReg_imm_rule: {
      xorI_eReg_immNode *node = new (C) xorI_eReg_immNode();
      return node;
    }
  case xorI_eReg_mem_rule: {
      xorI_eReg_memNode *node = new (C) xorI_eReg_memNode();
      return node;
    }
  case xorI_eReg_mem_0_rule: {
      xorI_eReg_mem_0Node *node = new (C) xorI_eReg_mem_0Node();
      return node;
    }
  case xorI_mem_eReg_rule: {
      xorI_mem_eRegNode *node = new (C) xorI_mem_eRegNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case xorI_mem_eReg_0_rule: {
      xorI_mem_eReg_0Node *node = new (C) xorI_mem_eReg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case xorI_mem_imm_rule: {
      xorI_mem_immNode *node = new (C) xorI_mem_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case convI2B_rule: {
      convI2BNode *node = new (C) convI2BNode();
      return node;
    }
  case convP2B_rule: {
      convP2BNode *node = new (C) convP2BNode();
      return node;
    }
  case cmpLTMask_rule: {
      cmpLTMaskNode *node = new (C) cmpLTMaskNode();
      return node;
    }
  case cmpLTMask0_rule: {
      cmpLTMask0Node *node = new (C) cmpLTMask0Node();
      return node;
    }
  case cadd_cmpLTMask_rule: {
      cadd_cmpLTMaskNode *node = new (C) cadd_cmpLTMaskNode();
      return node;
    }
  case cadd_cmpLTMask_1_rule: {
      cadd_cmpLTMask_1Node *node = new (C) cadd_cmpLTMask_1Node();
      return node;
    }
  case cadd_cmpLTMask_0_rule: {
      cadd_cmpLTMask_0Node *node = new (C) cadd_cmpLTMask_0Node();
      return node;
    }
  case cadd_cmpLTMask_2_rule: {
      cadd_cmpLTMask_2Node *node = new (C) cadd_cmpLTMask_2Node();
      return node;
    }
  case and_cmpLTMask_rule: {
      and_cmpLTMaskNode *node = new (C) and_cmpLTMaskNode();
      return node;
    }
  case and_cmpLTMask_0_rule: {
      and_cmpLTMask_0Node *node = new (C) and_cmpLTMask_0Node();
      return node;
    }
  case overflowAddI_eReg_rule: {
      overflowAddI_eRegNode *node = new (C) overflowAddI_eRegNode();
      return node;
    }
  case overflowAddI_rReg_imm_rule: {
      overflowAddI_rReg_immNode *node = new (C) overflowAddI_rReg_immNode();
      return node;
    }
  case overflowSubI_rReg_rule: {
      overflowSubI_rRegNode *node = new (C) overflowSubI_rRegNode();
      return node;
    }
  case overflowSubI_rReg_imm_rule: {
      overflowSubI_rReg_immNode *node = new (C) overflowSubI_rReg_immNode();
      return node;
    }
  case overflowNegI_rReg_rule: {
      overflowNegI_rRegNode *node = new (C) overflowNegI_rRegNode();
      return node;
    }
  case overflowMulI_rReg_rule: {
      overflowMulI_rRegNode *node = new (C) overflowMulI_rRegNode();
      return node;
    }
  case overflowMulI_rReg_imm_rule: {
      overflowMulI_rReg_immNode *node = new (C) overflowMulI_rReg_immNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case addL_eReg_rule: {
      addL_eRegNode *node = new (C) addL_eRegNode();
      return node;
    }
  case addL_eReg_imm_rule: {
      addL_eReg_immNode *node = new (C) addL_eReg_immNode();
      return node;
    }
  case addL_eReg_mem_rule: {
      addL_eReg_memNode *node = new (C) addL_eReg_memNode();
      return node;
    }
  case addL_eReg_mem_0_rule: {
      addL_eReg_mem_0Node *node = new (C) addL_eReg_mem_0Node();
      return node;
    }
  case subL_eReg_rule: {
      subL_eRegNode *node = new (C) subL_eRegNode();
      return node;
    }
  case subL_eReg_imm_rule: {
      subL_eReg_immNode *node = new (C) subL_eReg_immNode();
      return node;
    }
  case subL_eReg_mem_rule: {
      subL_eReg_memNode *node = new (C) subL_eReg_memNode();
      return node;
    }
  case negL_eReg_rule: {
      negL_eRegNode *node = new (C) negL_eRegNode();
      return node;
    }
  case andL_eReg_rule: {
      andL_eRegNode *node = new (C) andL_eRegNode();
      return node;
    }
  case andL_eReg_imm_rule: {
      andL_eReg_immNode *node = new (C) andL_eReg_immNode();
      return node;
    }
  case andL_eReg_mem_rule: {
      andL_eReg_memNode *node = new (C) andL_eReg_memNode();
      return node;
    }
  case andL_eReg_mem_0_rule: {
      andL_eReg_mem_0Node *node = new (C) andL_eReg_mem_0Node();
      return node;
    }
  case andnL_eReg_eReg_eReg_rule: {
      andnL_eReg_eReg_eRegNode *node = new (C) andnL_eReg_eReg_eRegNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case andnL_eReg_eReg_eReg_0_rule: {
      andnL_eReg_eReg_eReg_0Node *node = new (C) andnL_eReg_eReg_eReg_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case andnL_eReg_eReg_mem_rule: {
      andnL_eReg_eReg_memNode *node = new (C) andnL_eReg_eReg_memNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case andnL_eReg_eReg_mem_0_rule: {
      andnL_eReg_eReg_mem_0Node *node = new (C) andnL_eReg_eReg_mem_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case blsiL_eReg_eReg_rule: {
      blsiL_eReg_eRegNode *node = new (C) blsiL_eReg_eRegNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case blsiL_eReg_eReg_0_rule: {
      blsiL_eReg_eReg_0Node *node = new (C) blsiL_eReg_eReg_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case blsiL_eReg_mem_rule: {
      blsiL_eReg_memNode *node = new (C) blsiL_eReg_memNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case blsiL_eReg_mem_0_rule: {
      blsiL_eReg_mem_0Node *node = new (C) blsiL_eReg_mem_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case blsmskL_eReg_eReg_rule: {
      blsmskL_eReg_eRegNode *node = new (C) blsmskL_eReg_eRegNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case blsmskL_eReg_eReg_0_rule: {
      blsmskL_eReg_eReg_0Node *node = new (C) blsmskL_eReg_eReg_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case blsmskL_eReg_mem_rule: {
      blsmskL_eReg_memNode *node = new (C) blsmskL_eReg_memNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case blsmskL_eReg_mem_0_rule: {
      blsmskL_eReg_mem_0Node *node = new (C) blsmskL_eReg_mem_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case blsrL_eReg_eReg_rule: {
      blsrL_eReg_eRegNode *node = new (C) blsrL_eReg_eRegNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case blsrL_eReg_eReg_0_rule: {
      blsrL_eReg_eReg_0Node *node = new (C) blsrL_eReg_eReg_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case blsrL_eReg_mem_rule: {
      blsrL_eReg_memNode *node = new (C) blsrL_eReg_memNode();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case blsrL_eReg_mem_0_rule: {
      blsrL_eReg_mem_0Node *node = new (C) blsrL_eReg_mem_0Node();
      node->set_opnd_array(4, MachOperGenerator(EREGL, C));
      return node;
    }
  case orl_eReg_rule: {
      orl_eRegNode *node = new (C) orl_eRegNode();
      return node;
    }
  case orl_eReg_imm_rule: {
      orl_eReg_immNode *node = new (C) orl_eReg_immNode();
      return node;
    }
  case orl_eReg_mem_rule: {
      orl_eReg_memNode *node = new (C) orl_eReg_memNode();
      return node;
    }
  case orl_eReg_mem_0_rule: {
      orl_eReg_mem_0Node *node = new (C) orl_eReg_mem_0Node();
      return node;
    }
  case xorl_eReg_rule: {
      xorl_eRegNode *node = new (C) xorl_eRegNode();
      return node;
    }
  case xorl_eReg_im1_rule: {
      xorl_eReg_im1Node *node = new (C) xorl_eReg_im1Node();
      return node;
    }
  case xorl_eReg_imm_rule: {
      xorl_eReg_immNode *node = new (C) xorl_eReg_immNode();
      return node;
    }
  case xorl_eReg_mem_rule: {
      xorl_eReg_memNode *node = new (C) xorl_eReg_memNode();
      return node;
    }
  case xorl_eReg_mem_0_rule: {
      xorl_eReg_mem_0Node *node = new (C) xorl_eReg_mem_0Node();
      return node;
    }
  case shlL_eReg_1_rule: {
      shlL_eReg_1Node *node = new (C) shlL_eReg_1Node();
      return node;
    }
  case shlL_eReg_2_rule: {
      shlL_eReg_2Node *node = new (C) shlL_eReg_2Node();
      return node;
    }
  case shlL_eReg_3_rule: {
      shlL_eReg_3Node *node = new (C) shlL_eReg_3Node();
      return node;
    }
  case shlL_eReg_1_31_rule: {
      shlL_eReg_1_31Node *node = new (C) shlL_eReg_1_31Node();
      return node;
    }
  case shlL_eReg_32_63_rule: {
      shlL_eReg_32_63Node *node = new (C) shlL_eReg_32_63Node();
      return node;
    }
  case salL_eReg_CL_rule: {
      salL_eReg_CLNode *node = new (C) salL_eReg_CLNode();
      return node;
    }
  case shrL_eReg_1_31_rule: {
      shrL_eReg_1_31Node *node = new (C) shrL_eReg_1_31Node();
      return node;
    }
  case shrL_eReg_32_63_rule: {
      shrL_eReg_32_63Node *node = new (C) shrL_eReg_32_63Node();
      return node;
    }
  case shrL_eReg_CL_rule: {
      shrL_eReg_CLNode *node = new (C) shrL_eReg_CLNode();
      return node;
    }
  case sarL_eReg_1_31_rule: {
      sarL_eReg_1_31Node *node = new (C) sarL_eReg_1_31Node();
      return node;
    }
  case sarL_eReg_32_63_rule: {
      sarL_eReg_32_63Node *node = new (C) sarL_eReg_32_63Node();
      return node;
    }
  case sarL_eReg_CL_rule: {
      sarL_eReg_CLNode *node = new (C) sarL_eReg_CLNode();
      return node;
    }
  case cmpDPR_cc_P6_rule: {
      cmpDPR_cc_P6Node *node = new (C) cmpDPR_cc_P6Node();
      return node;
    }
  case cmpDPR_cc_P6CF_rule: {
      cmpDPR_cc_P6CFNode *node = new (C) cmpDPR_cc_P6CFNode();
      return node;
    }
  case cmpDPR_cc_rule: {
      cmpDPR_ccNode *node = new (C) cmpDPR_ccNode();
      return node;
    }
  case cmpDPR_0_rule: {
      cmpDPR_0Node *node = new (C) cmpDPR_0Node();
      return node;
    }
  case cmpDPR_reg_rule: {
      cmpDPR_regNode *node = new (C) cmpDPR_regNode();
      return node;
    }
  case cmpD_cc_rule: {
      cmpD_ccNode *node = new (C) cmpD_ccNode();
      return node;
    }
  case cmpD_ccCF_rule: {
      cmpD_ccCFNode *node = new (C) cmpD_ccCFNode();
      return node;
    }
  case cmpD_ccmem_rule: {
      cmpD_ccmemNode *node = new (C) cmpD_ccmemNode();
      return node;
    }
  case cmpD_ccmemCF_rule: {
      cmpD_ccmemCFNode *node = new (C) cmpD_ccmemCFNode();
      return node;
    }
  case cmpD_reg_rule: {
      cmpD_regNode *node = new (C) cmpD_regNode();
      return node;
    }
  case cmpD_regmem_rule: {
      cmpD_regmemNode *node = new (C) cmpD_regmemNode();
      return node;
    }
  case subDPR_reg_rule: {
      subDPR_regNode *node = new (C) subDPR_regNode();
      return node;
    }
  case subDPR_reg_round_rule: {
      subDPR_reg_roundNode *node = new (C) subDPR_reg_roundNode();
      return node;
    }
  case subDPR_reg_mem_rule: {
      subDPR_reg_memNode *node = new (C) subDPR_reg_memNode();
      return node;
    }
  case absDPR_reg_rule: {
      absDPR_regNode *node = new (C) absDPR_regNode();
      return node;
    }
  case negDPR_reg_rule: {
      negDPR_regNode *node = new (C) negDPR_regNode();
      return node;
    }
  case addDPR_reg_rule: {
      addDPR_regNode *node = new (C) addDPR_regNode();
      return node;
    }
  case addDPR_reg_round_rule: {
      addDPR_reg_roundNode *node = new (C) addDPR_reg_roundNode();
      return node;
    }
  case addDPR_reg_mem_rule: {
      addDPR_reg_memNode *node = new (C) addDPR_reg_memNode();
      return node;
    }
  case addDPR_reg_mem_0_rule: {
      addDPR_reg_mem_0Node *node = new (C) addDPR_reg_mem_0Node();
      return node;
    }
  case addDPR_mem_reg_rule: {
      addDPR_mem_regNode *node = new (C) addDPR_mem_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addDPR_mem_reg_0_rule: {
      addDPR_mem_reg_0Node *node = new (C) addDPR_mem_reg_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addDPR_reg_imm1_rule: {
      addDPR_reg_imm1Node *node = new (C) addDPR_reg_imm1Node();
      return node;
    }
  case addDPR_reg_imm_rule: {
      addDPR_reg_immNode *node = new (C) addDPR_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addDPR_reg_imm_round_rule: {
      addDPR_reg_imm_roundNode *node = new (C) addDPR_reg_imm_roundNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulDPR_reg_rule: {
      mulDPR_regNode *node = new (C) mulDPR_regNode();
      return node;
    }
  case strictfp_mulDPR_reg_rule: {
      strictfp_mulDPR_regNode *node = new (C) strictfp_mulDPR_regNode();
      return node;
    }
  case mulDPR_reg_imm_rule: {
      mulDPR_reg_immNode *node = new (C) mulDPR_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulDPR_reg_mem_rule: {
      mulDPR_reg_memNode *node = new (C) mulDPR_reg_memNode();
      return node;
    }
  case mulDPR_reg_mem_0_rule: {
      mulDPR_reg_mem_0Node *node = new (C) mulDPR_reg_mem_0Node();
      return node;
    }
  case mulDPR_reg_mem_cisc_rule: {
      mulDPR_reg_mem_ciscNode *node = new (C) mulDPR_reg_mem_ciscNode();
      return node;
    }
  case mulDPR_reg_mem_cisc_0_rule: {
      mulDPR_reg_mem_cisc_0Node *node = new (C) mulDPR_reg_mem_cisc_0Node();
      return node;
    }
  case addDPR_mulDPR_reg_rule: {
      addDPR_mulDPR_regNode *node = new (C) addDPR_mulDPR_regNode();
      return node;
    }
  case addDPR_mulDPR_reg_0_rule: {
      addDPR_mulDPR_reg_0Node *node = new (C) addDPR_mulDPR_reg_0Node();
      return node;
    }
  case subDPR_mulDPR_reg_rule: {
      subDPR_mulDPR_regNode *node = new (C) subDPR_mulDPR_regNode();
      return node;
    }
  case divDPR_reg_rule: {
      divDPR_regNode *node = new (C) divDPR_regNode();
      return node;
    }
  case strictfp_divDPR_reg_rule: {
      strictfp_divDPR_regNode *node = new (C) strictfp_divDPR_regNode();
      return node;
    }
  case divDPR_reg_round_rule: {
      divDPR_reg_roundNode *node = new (C) divDPR_reg_roundNode();
      return node;
    }
  case modDPR_reg_rule: {
      modDPR_regNode *node = new (C) modDPR_regNode();
      return node;
    }
  case modD_reg_rule: {
      modD_regNode *node = new (C) modD_regNode();
      return node;
    }
  case sinDPR_reg_rule: {
      sinDPR_regNode *node = new (C) sinDPR_regNode();
      return node;
    }
  case sinD_reg_rule: {
      sinD_regNode *node = new (C) sinD_regNode();
      return node;
    }
  case cosDPR_reg_rule: {
      cosDPR_regNode *node = new (C) cosDPR_regNode();
      return node;
    }
  case cosD_reg_rule: {
      cosD_regNode *node = new (C) cosD_regNode();
      return node;
    }
  case tanDPR_reg_rule: {
      tanDPR_regNode *node = new (C) tanDPR_regNode();
      return node;
    }
  case tanD_reg_rule: {
      tanD_regNode *node = new (C) tanD_regNode();
      return node;
    }
  case atanDPR_reg_rule: {
      atanDPR_regNode *node = new (C) atanDPR_regNode();
      return node;
    }
  case atanD_reg_rule: {
      atanD_regNode *node = new (C) atanD_regNode();
      return node;
    }
  case sqrtDPR_reg_rule: {
      sqrtDPR_regNode *node = new (C) sqrtDPR_regNode();
      return node;
    }
  case powDPR_reg_rule: {
      powDPR_regNode *node = new (C) powDPR_regNode();
      return node;
    }
  case powD_reg_rule: {
      powD_regNode *node = new (C) powD_regNode();
      return node;
    }
  case expDPR_reg_rule: {
      expDPR_regNode *node = new (C) expDPR_regNode();
      return node;
    }
  case expD_reg_rule: {
      expD_regNode *node = new (C) expD_regNode();
      return node;
    }
  case log10DPR_reg_rule: {
      log10DPR_regNode *node = new (C) log10DPR_regNode();
      return node;
    }
  case log10D_reg_rule: {
      log10D_regNode *node = new (C) log10D_regNode();
      return node;
    }
  case logDPR_reg_rule: {
      logDPR_regNode *node = new (C) logDPR_regNode();
      return node;
    }
  case logD_reg_rule: {
      logD_regNode *node = new (C) logD_regNode();
      return node;
    }
  case cmpFPR_cc_P6_rule: {
      cmpFPR_cc_P6Node *node = new (C) cmpFPR_cc_P6Node();
      return node;
    }
  case cmpFPR_cc_P6CF_rule: {
      cmpFPR_cc_P6CFNode *node = new (C) cmpFPR_cc_P6CFNode();
      return node;
    }
  case cmpFPR_cc_rule: {
      cmpFPR_ccNode *node = new (C) cmpFPR_ccNode();
      return node;
    }
  case cmpFPR_0_rule: {
      cmpFPR_0Node *node = new (C) cmpFPR_0Node();
      return node;
    }
  case cmpFPR_reg_rule: {
      cmpFPR_regNode *node = new (C) cmpFPR_regNode();
      return node;
    }
  case cmpF_cc_rule: {
      cmpF_ccNode *node = new (C) cmpF_ccNode();
      return node;
    }
  case cmpF_ccCF_rule: {
      cmpF_ccCFNode *node = new (C) cmpF_ccCFNode();
      return node;
    }
  case cmpF_ccmem_rule: {
      cmpF_ccmemNode *node = new (C) cmpF_ccmemNode();
      return node;
    }
  case cmpF_ccmemCF_rule: {
      cmpF_ccmemCFNode *node = new (C) cmpF_ccmemCFNode();
      return node;
    }
  case cmpF_reg_rule: {
      cmpF_regNode *node = new (C) cmpF_regNode();
      return node;
    }
  case cmpF_regmem_rule: {
      cmpF_regmemNode *node = new (C) cmpF_regmemNode();
      return node;
    }
  case subFPR24_reg_rule: {
      subFPR24_regNode *node = new (C) subFPR24_regNode();
      return node;
    }
  case subFPR_reg_rule: {
      subFPR_regNode *node = new (C) subFPR_regNode();
      return node;
    }
  case addFPR24_reg_rule: {
      addFPR24_regNode *node = new (C) addFPR24_regNode();
      return node;
    }
  case addFPR_reg_rule: {
      addFPR_regNode *node = new (C) addFPR_regNode();
      return node;
    }
  case absFPR_reg_rule: {
      absFPR_regNode *node = new (C) absFPR_regNode();
      return node;
    }
  case negFPR_reg_rule: {
      negFPR_regNode *node = new (C) negFPR_regNode();
      return node;
    }
  case addFPR24_reg_mem_rule: {
      addFPR24_reg_memNode *node = new (C) addFPR24_reg_memNode();
      return node;
    }
  case addFPR24_reg_mem_0_rule: {
      addFPR24_reg_mem_0Node *node = new (C) addFPR24_reg_mem_0Node();
      return node;
    }
  case addFPR_reg_mem_rule: {
      addFPR_reg_memNode *node = new (C) addFPR_reg_memNode();
      return node;
    }
  case addFPR_reg_mem_0_rule: {
      addFPR_reg_mem_0Node *node = new (C) addFPR_reg_mem_0Node();
      return node;
    }
  case addFPR24_mem_reg_rule: {
      addFPR24_mem_regNode *node = new (C) addFPR24_mem_regNode();
      return node;
    }
  case addFPR24_mem_cisc_rule: {
      addFPR24_mem_ciscNode *node = new (C) addFPR24_mem_ciscNode();
      return node;
    }
  case addFPR24_mem_cisc_0_rule: {
      addFPR24_mem_cisc_0Node *node = new (C) addFPR24_mem_cisc_0Node();
      return node;
    }
  case addFPR24_mem_mem_rule: {
      addFPR24_mem_memNode *node = new (C) addFPR24_mem_memNode();
      return node;
    }
  case addFPR24_reg_imm_rule: {
      addFPR24_reg_immNode *node = new (C) addFPR24_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addFPR_reg_imm_rule: {
      addFPR_reg_immNode *node = new (C) addFPR_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulFPR24_reg_rule: {
      mulFPR24_regNode *node = new (C) mulFPR24_regNode();
      return node;
    }
  case mulFPR_reg_rule: {
      mulFPR_regNode *node = new (C) mulFPR_regNode();
      return node;
    }
  case mulFPR24_reg_mem_rule: {
      mulFPR24_reg_memNode *node = new (C) mulFPR24_reg_memNode();
      return node;
    }
  case mulFPR24_reg_mem_0_rule: {
      mulFPR24_reg_mem_0Node *node = new (C) mulFPR24_reg_mem_0Node();
      return node;
    }
  case mulFPR_reg_mem_rule: {
      mulFPR_reg_memNode *node = new (C) mulFPR_reg_memNode();
      return node;
    }
  case mulFPR_reg_mem_0_rule: {
      mulFPR_reg_mem_0Node *node = new (C) mulFPR_reg_mem_0Node();
      return node;
    }
  case mulFPR24_mem_mem_rule: {
      mulFPR24_mem_memNode *node = new (C) mulFPR24_mem_memNode();
      return node;
    }
  case mulFPR24_reg_imm_rule: {
      mulFPR24_reg_immNode *node = new (C) mulFPR24_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulFPR_reg_imm_rule: {
      mulFPR_reg_immNode *node = new (C) mulFPR_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulFPR_reg_load1_rule: {
      mulFPR_reg_load1Node *node = new (C) mulFPR_reg_load1Node();
      return node;
    }
  case mulFPR_reg_load1_0_rule: {
      mulFPR_reg_load1_0Node *node = new (C) mulFPR_reg_load1_0Node();
      return node;
    }
  case addFPR_mulFPR_reg_load1_rule: {
      addFPR_mulFPR_reg_load1Node *node = new (C) addFPR_mulFPR_reg_load1Node();
      return node;
    }
  case addFPR_mulFPR_reg_load1_1_rule: {
      addFPR_mulFPR_reg_load1_1Node *node = new (C) addFPR_mulFPR_reg_load1_1Node();
      return node;
    }
  case addFPR_mulFPR_reg_load1_0_rule: {
      addFPR_mulFPR_reg_load1_0Node *node = new (C) addFPR_mulFPR_reg_load1_0Node();
      return node;
    }
  case addFPR_mulFPR_reg_load1_2_rule: {
      addFPR_mulFPR_reg_load1_2Node *node = new (C) addFPR_mulFPR_reg_load1_2Node();
      return node;
    }
  case addFPR_mulFPR_reg_rule: {
      addFPR_mulFPR_regNode *node = new (C) addFPR_mulFPR_regNode();
      return node;
    }
  case addFPR_mulFPR_reg_0_rule: {
      addFPR_mulFPR_reg_0Node *node = new (C) addFPR_mulFPR_reg_0Node();
      return node;
    }
  case subFPR_divFPR_reg_rule: {
      subFPR_divFPR_regNode *node = new (C) subFPR_divFPR_regNode();
      return node;
    }
  case divFPR24_reg_rule: {
      divFPR24_regNode *node = new (C) divFPR24_regNode();
      return node;
    }
  case divFPR_reg_rule: {
      divFPR_regNode *node = new (C) divFPR_regNode();
      return node;
    }
  case modFPR24_reg_rule: {
      modFPR24_regNode *node = new (C) modFPR24_regNode();
      return node;
    }
  case modFPR_reg_rule: {
      modFPR_regNode *node = new (C) modFPR_regNode();
      return node;
    }
  case modF_reg_rule: {
      modF_regNode *node = new (C) modF_regNode();
      return node;
    }
  case roundFloat_mem_reg_rule: {
      roundFloat_mem_regNode *node = new (C) roundFloat_mem_regNode();
      return node;
    }
  case roundDouble_mem_reg_rule: {
      roundDouble_mem_regNode *node = new (C) roundDouble_mem_regNode();
      return node;
    }
  case convDPR2FPR_reg_rule: {
      convDPR2FPR_regNode *node = new (C) convDPR2FPR_regNode();
      return node;
    }
  case convDPR2F_reg_rule: {
      convDPR2F_regNode *node = new (C) convDPR2F_regNode();
      return node;
    }
  case convD2F_reg_rule: {
      convD2F_regNode *node = new (C) convD2F_regNode();
      return node;
    }
  case convFPR2DPR_reg_reg_rule: {
      convFPR2DPR_reg_regNode *node = new (C) convFPR2DPR_reg_regNode();
      return node;
    }
  case convFPR2D_reg_rule: {
      convFPR2D_regNode *node = new (C) convFPR2D_regNode();
      return node;
    }
  case convF2DPR_reg_rule: {
      convF2DPR_regNode *node = new (C) convF2DPR_regNode();
      return node;
    }
  case convF2D_reg_rule: {
      convF2D_regNode *node = new (C) convF2D_regNode();
      return node;
    }
  case convDPR2I_reg_reg_rule: {
      convDPR2I_reg_regNode *node = new (C) convDPR2I_reg_regNode();
      return node;
    }
  case convD2I_reg_reg_rule: {
      convD2I_reg_regNode *node = new (C) convD2I_reg_regNode();
      return node;
    }
  case convDPR2L_reg_reg_rule: {
      convDPR2L_reg_regNode *node = new (C) convDPR2L_reg_regNode();
      return node;
    }
  case convD2L_reg_reg_rule: {
      convD2L_reg_regNode *node = new (C) convD2L_reg_regNode();
      return node;
    }
  case convFPR2I_reg_reg_rule: {
      convFPR2I_reg_regNode *node = new (C) convFPR2I_reg_regNode();
      return node;
    }
  case convF2I_reg_rule: {
      convF2I_regNode *node = new (C) convF2I_regNode();
      return node;
    }
  case convFPR2L_reg_reg_rule: {
      convFPR2L_reg_regNode *node = new (C) convFPR2L_reg_regNode();
      return node;
    }
  case convF2L_reg_reg_rule: {
      convF2L_reg_regNode *node = new (C) convF2L_reg_regNode();
      return node;
    }
  case convI2DPR_reg_rule: {
      convI2DPR_regNode *node = new (C) convI2DPR_regNode();
      return node;
    }
  case convI2D_reg_rule: {
      convI2D_regNode *node = new (C) convI2D_regNode();
      return node;
    }
  case convI2D_mem_rule: {
      convI2D_memNode *node = new (C) convI2D_memNode();
      return node;
    }
  case convXI2D_reg_rule: {
      convXI2D_regNode *node = new (C) convXI2D_regNode();
      return node;
    }
  case convI2DPR_mem_rule: {
      convI2DPR_memNode *node = new (C) convI2DPR_memNode();
      return node;
    }
  case conv24I2FPR_reg_rule: {
      conv24I2FPR_regNode *node = new (C) conv24I2FPR_regNode();
      return node;
    }
  case convI2FPR_SSF_rule: {
      convI2FPR_SSFNode *node = new (C) convI2FPR_SSFNode();
      return node;
    }
  case convI2FPR_SSF_mem_rule: {
      convI2FPR_SSF_memNode *node = new (C) convI2FPR_SSF_memNode();
      return node;
    }
  case convI2FPR_reg_rule: {
      convI2FPR_regNode *node = new (C) convI2FPR_regNode();
      return node;
    }
  case convI2FPR_mem_rule: {
      convI2FPR_memNode *node = new (C) convI2FPR_memNode();
      return node;
    }
  case convI2F_reg_rule: {
      convI2F_regNode *node = new (C) convI2F_regNode();
      return node;
    }
  case convXI2F_reg_rule: {
      convXI2F_regNode *node = new (C) convXI2F_regNode();
      return node;
    }
  case convI2L_reg_rule: {
      convI2L_regNode *node = new (C) convI2L_regNode();
      return node;
    }
  case convI2L_reg_zex_rule: {
      convI2L_reg_zexNode *node = new (C) convI2L_reg_zexNode();
      return node;
    }
  case zerox_long_rule: {
      zerox_longNode *node = new (C) zerox_longNode();
      return node;
    }
  case convL2DPR_reg_rule: {
      convL2DPR_regNode *node = new (C) convL2DPR_regNode();
      return node;
    }
  case convL2D_reg_rule: {
      convL2D_regNode *node = new (C) convL2D_regNode();
      return node;
    }
  case convL2F_reg_rule: {
      convL2F_regNode *node = new (C) convL2F_regNode();
      return node;
    }
  case convL2FPR_reg_rule: {
      convL2FPR_regNode *node = new (C) convL2FPR_regNode();
      return node;
    }
  case convL2I_reg_rule: {
      convL2I_regNode *node = new (C) convL2I_regNode();
      return node;
    }
  case MoveF2I_stack_reg_rule: {
      MoveF2I_stack_regNode *node = new (C) MoveF2I_stack_regNode();
      return node;
    }
  case MoveFPR2I_reg_stack_rule: {
      MoveFPR2I_reg_stackNode *node = new (C) MoveFPR2I_reg_stackNode();
      return node;
    }
  case MoveF2I_reg_stack_sse_rule: {
      MoveF2I_reg_stack_sseNode *node = new (C) MoveF2I_reg_stack_sseNode();
      return node;
    }
  case MoveF2I_reg_reg_sse_rule: {
      MoveF2I_reg_reg_sseNode *node = new (C) MoveF2I_reg_reg_sseNode();
      return node;
    }
  case MoveI2F_reg_stack_rule: {
      MoveI2F_reg_stackNode *node = new (C) MoveI2F_reg_stackNode();
      return node;
    }
  case MoveI2FPR_stack_reg_rule: {
      MoveI2FPR_stack_regNode *node = new (C) MoveI2FPR_stack_regNode();
      return node;
    }
  case MoveI2F_stack_reg_sse_rule: {
      MoveI2F_stack_reg_sseNode *node = new (C) MoveI2F_stack_reg_sseNode();
      return node;
    }
  case MoveI2F_reg_reg_sse_rule: {
      MoveI2F_reg_reg_sseNode *node = new (C) MoveI2F_reg_reg_sseNode();
      return node;
    }
  case MoveD2L_stack_reg_rule: {
      MoveD2L_stack_regNode *node = new (C) MoveD2L_stack_regNode();
      return node;
    }
  case MoveDPR2L_reg_stack_rule: {
      MoveDPR2L_reg_stackNode *node = new (C) MoveDPR2L_reg_stackNode();
      return node;
    }
  case MoveD2L_reg_stack_sse_rule: {
      MoveD2L_reg_stack_sseNode *node = new (C) MoveD2L_reg_stack_sseNode();
      return node;
    }
  case MoveD2L_reg_reg_sse_rule: {
      MoveD2L_reg_reg_sseNode *node = new (C) MoveD2L_reg_reg_sseNode();
      node->set_opnd_array(2, MachOperGenerator(REGD, C));
      return node;
    }
  case MoveL2D_reg_stack_rule: {
      MoveL2D_reg_stackNode *node = new (C) MoveL2D_reg_stackNode();
      return node;
    }
  case MoveL2DPR_stack_reg_rule: {
      MoveL2DPR_stack_regNode *node = new (C) MoveL2DPR_stack_regNode();
      return node;
    }
  case MoveL2D_stack_reg_sse_rule: {
      MoveL2D_stack_reg_sseNode *node = new (C) MoveL2D_stack_reg_sseNode();
      return node;
    }
  case MoveL2D_stack_reg_sse_partial_rule: {
      MoveL2D_stack_reg_sse_partialNode *node = new (C) MoveL2D_stack_reg_sse_partialNode();
      return node;
    }
  case MoveL2D_reg_reg_sse_rule: {
      MoveL2D_reg_reg_sseNode *node = new (C) MoveL2D_reg_reg_sseNode();
      node->set_opnd_array(2, MachOperGenerator(REGD, C));
      node->set_opnd_array(3, MachOperGenerator(REGD, C));
      return node;
    }
  case rep_stos_rule: {
      rep_stosNode *node = new (C) rep_stosNode();
      return node;
    }
  case rep_fast_stosb_rule: {
      rep_fast_stosbNode *node = new (C) rep_fast_stosbNode();
      return node;
    }
  case string_compare_rule: {
      string_compareNode *node = new (C) string_compareNode();
      node->set_opnd_array(5, MachOperGenerator(REGD, C));
      return node;
    }
  case string_equals_rule: {
      string_equalsNode *node = new (C) string_equalsNode();
      node->set_opnd_array(4, MachOperGenerator(REGD, C));
      node->set_opnd_array(5, MachOperGenerator(REGD, C));
      return node;
    }
  case string_indexof_con_rule: {
      string_indexof_conNode *node = new (C) string_indexof_conNode();
      node->set_opnd_array(5, MachOperGenerator(REGD, C));
      return node;
    }
  case string_indexof_rule: {
      string_indexofNode *node = new (C) string_indexofNode();
      node->set_opnd_array(5, MachOperGenerator(REGD, C));
      return node;
    }
  case array_equals_rule: {
      array_equalsNode *node = new (C) array_equalsNode();
      node->set_opnd_array(3, MachOperGenerator(REGD, C));
      node->set_opnd_array(4, MachOperGenerator(REGD, C));
      return node;
    }
  case encode_iso_array_rule: {
      encode_iso_arrayNode *node = new (C) encode_iso_arrayNode();
      node->set_opnd_array(4, MachOperGenerator(REGD, C));
      node->set_opnd_array(5, MachOperGenerator(REGD, C));
      node->set_opnd_array(6, MachOperGenerator(REGD, C));
      node->set_opnd_array(7, MachOperGenerator(REGD, C));
      return node;
    }
  case compI_eReg_rule: {
      compI_eRegNode *node = new (C) compI_eRegNode();
      return node;
    }
  case compI_eReg_imm_rule: {
      compI_eReg_immNode *node = new (C) compI_eReg_immNode();
      return node;
    }
  case compI_eReg_mem_rule: {
      compI_eReg_memNode *node = new (C) compI_eReg_memNode();
      return node;
    }
  case testI_reg_rule: {
      testI_regNode *node = new (C) testI_regNode();
      return node;
    }
  case testI_reg_imm_rule: {
      testI_reg_immNode *node = new (C) testI_reg_immNode();
      return node;
    }
  case testI_reg_mem_rule: {
      testI_reg_memNode *node = new (C) testI_reg_memNode();
      return node;
    }
  case compU_eReg_rule: {
      compU_eRegNode *node = new (C) compU_eRegNode();
      return node;
    }
  case compU_eReg_imm_rule: {
      compU_eReg_immNode *node = new (C) compU_eReg_immNode();
      return node;
    }
  case compU_eReg_mem_rule: {
      compU_eReg_memNode *node = new (C) compU_eReg_memNode();
      return node;
    }
  case testU_reg_rule: {
      testU_regNode *node = new (C) testU_regNode();
      return node;
    }
  case compP_eReg_rule: {
      compP_eRegNode *node = new (C) compP_eRegNode();
      return node;
    }
  case compP_eReg_imm_rule: {
      compP_eReg_immNode *node = new (C) compP_eReg_immNode();
      return node;
    }
  case compP_eReg_mem_rule: {
      compP_eReg_memNode *node = new (C) compP_eReg_memNode();
      return node;
    }
  case compP_mem_eReg_rule: {
      compP_mem_eRegNode *node = new (C) compP_mem_eRegNode();
      return node;
    }
  case testP_reg_rule: {
      testP_regNode *node = new (C) testP_regNode();
      return node;
    }
  case testP_Reg_mem_rule: {
      testP_Reg_memNode *node = new (C) testP_Reg_memNode();
      return node;
    }
  case minI_eReg_rule: {
      minI_eRegNode *node = new (C) minI_eRegNode();
      return node;
    }
  case maxI_eReg_rule: {
      maxI_eRegNode *node = new (C) maxI_eRegNode();
      return node;
    }
  case loopLimit_eReg_rule: {
      loopLimit_eRegNode *node = new (C) loopLimit_eRegNode();
      node->set_opnd_array(4, MachOperGenerator(EDXREGI, C));
      node->set_opnd_array(5, MachOperGenerator(NADXREGI, C));
      return node;
    }
  case jumpXtnd_rule: {
      jumpXtndNode *node = new (C) jumpXtndNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case jmpDir_rule: {
      jmpDirNode *node = new (C) jmpDirNode();
      node->set_opnd_array(1, MachOperGenerator(LABEL, C));
      return node;
    }
  case jmpCon_rule: {
      jmpConNode *node = new (C) jmpConNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEnd_rule: {
      jmpLoopEndNode *node = new (C) jmpLoopEndNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEndU_rule: {
      jmpLoopEndUNode *node = new (C) jmpLoopEndUNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEndUCF_rule: {
      jmpLoopEndUCFNode *node = new (C) jmpLoopEndUCFNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpConU_rule: {
      jmpConUNode *node = new (C) jmpConUNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpConUCF_rule: {
      jmpConUCFNode *node = new (C) jmpConUCFNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpConUCF2_rule: {
      jmpConUCF2Node *node = new (C) jmpConUCF2Node();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case partialSubtypeCheck_rule: {
      partialSubtypeCheckNode *node = new (C) partialSubtypeCheckNode();
      return node;
    }
  case partialSubtypeCheck_vs_Zero_rule: {
      partialSubtypeCheck_vs_ZeroNode *node = new (C) partialSubtypeCheck_vs_ZeroNode();
      return node;
    }
  case jmpDir_short_rule: {
      jmpDir_shortNode *node = new (C) jmpDir_shortNode();
      node->set_opnd_array(1, MachOperGenerator(LABEL, C));
      return node;
    }
  case jmpCon_short_rule: {
      jmpCon_shortNode *node = new (C) jmpCon_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEnd_short_rule: {
      jmpLoopEnd_shortNode *node = new (C) jmpLoopEnd_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEndU_short_rule: {
      jmpLoopEndU_shortNode *node = new (C) jmpLoopEndU_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEndUCF_short_rule: {
      jmpLoopEndUCF_shortNode *node = new (C) jmpLoopEndUCF_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpConU_short_rule: {
      jmpConU_shortNode *node = new (C) jmpConU_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpConUCF_short_rule: {
      jmpConUCF_shortNode *node = new (C) jmpConUCF_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpConUCF2_short_rule: {
      jmpConUCF2_shortNode *node = new (C) jmpConUCF2_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL3_reg_reg_rule: {
      cmpL3_reg_regNode *node = new (C) cmpL3_reg_regNode();
      return node;
    }
  case cmpL_zero_flags_LTGE_rule: {
      cmpL_zero_flags_LTGENode *node = new (C) cmpL_zero_flags_LTGENode();
      return node;
    }
  case cmpL_reg_flags_LTGE_rule: {
      cmpL_reg_flags_LTGENode *node = new (C) cmpL_reg_flags_LTGENode();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case cmpL_LTGE_rule: {
      cmpL_LTGENode *node = new (C) cmpL_LTGENode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUL_zero_flags_LTGE_rule: {
      cmpUL_zero_flags_LTGENode *node = new (C) cmpUL_zero_flags_LTGENode();
      return node;
    }
  case cmpUL_reg_flags_LTGE_rule: {
      cmpUL_reg_flags_LTGENode *node = new (C) cmpUL_reg_flags_LTGENode();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case cmpUL_LTGE_rule: {
      cmpUL_LTGENode *node = new (C) cmpUL_LTGENode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmovLL_reg_LTGE_rule: {
      cmovLL_reg_LTGENode *node = new (C) cmovLL_reg_LTGENode();
      return node;
    }
  case cmovLL_mem_LTGE_rule: {
      cmovLL_mem_LTGENode *node = new (C) cmovLL_mem_LTGENode();
      return node;
    }
  case cmovII_reg_LTGE_rule: {
      cmovII_reg_LTGENode *node = new (C) cmovII_reg_LTGENode();
      return node;
    }
  case cmovII_mem_LTGE_rule: {
      cmovII_mem_LTGENode *node = new (C) cmovII_mem_LTGENode();
      return node;
    }
  case cmovPP_reg_LTGE_rule: {
      cmovPP_reg_LTGENode *node = new (C) cmovPP_reg_LTGENode();
      return node;
    }
  case cmovDDPR_reg_LTGE_rule: {
      cmovDDPR_reg_LTGENode *node = new (C) cmovDDPR_reg_LTGENode();
      return node;
    }
  case cmovDD_reg_LTGE_rule: {
      cmovDD_reg_LTGENode *node = new (C) cmovDD_reg_LTGENode();
      return node;
    }
  case cmovFFPR_reg_LTGE_rule: {
      cmovFFPR_reg_LTGENode *node = new (C) cmovFFPR_reg_LTGENode();
      return node;
    }
  case cmovFF_reg_LTGE_rule: {
      cmovFF_reg_LTGENode *node = new (C) cmovFF_reg_LTGENode();
      return node;
    }
  case cmpL_zero_flags_EQNE_rule: {
      cmpL_zero_flags_EQNENode *node = new (C) cmpL_zero_flags_EQNENode();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case cmpL_reg_flags_EQNE_rule: {
      cmpL_reg_flags_EQNENode *node = new (C) cmpL_reg_flags_EQNENode();
      return node;
    }
  case cmpL_EQNE_rule: {
      cmpL_EQNENode *node = new (C) cmpL_EQNENode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUL_zero_flags_EQNE_rule: {
      cmpUL_zero_flags_EQNENode *node = new (C) cmpUL_zero_flags_EQNENode();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case cmpUL_reg_flags_EQNE_rule: {
      cmpUL_reg_flags_EQNENode *node = new (C) cmpUL_reg_flags_EQNENode();
      return node;
    }
  case cmpUL_EQNE_rule: {
      cmpUL_EQNENode *node = new (C) cmpUL_EQNENode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmovLL_reg_EQNE_rule: {
      cmovLL_reg_EQNENode *node = new (C) cmovLL_reg_EQNENode();
      return node;
    }
  case cmovLL_mem_EQNE_rule: {
      cmovLL_mem_EQNENode *node = new (C) cmovLL_mem_EQNENode();
      return node;
    }
  case cmovII_reg_EQNE_rule: {
      cmovII_reg_EQNENode *node = new (C) cmovII_reg_EQNENode();
      return node;
    }
  case cmovII_mem_EQNE_rule: {
      cmovII_mem_EQNENode *node = new (C) cmovII_mem_EQNENode();
      return node;
    }
  case cmovPP_reg_EQNE_rule: {
      cmovPP_reg_EQNENode *node = new (C) cmovPP_reg_EQNENode();
      return node;
    }
  case cmovDDPR_reg_EQNE_rule: {
      cmovDDPR_reg_EQNENode *node = new (C) cmovDDPR_reg_EQNENode();
      return node;
    }
  case cmovDD_reg_EQNE_rule: {
      cmovDD_reg_EQNENode *node = new (C) cmovDD_reg_EQNENode();
      return node;
    }
  case cmovFFPR_reg_EQNE_rule: {
      cmovFFPR_reg_EQNENode *node = new (C) cmovFFPR_reg_EQNENode();
      return node;
    }
  case cmovFF_reg_EQNE_rule: {
      cmovFF_reg_EQNENode *node = new (C) cmovFF_reg_EQNENode();
      return node;
    }
  case cmpL_zero_flags_LEGT_rule: {
      cmpL_zero_flags_LEGTNode *node = new (C) cmpL_zero_flags_LEGTNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case cmpL_reg_flags_LEGT_rule: {
      cmpL_reg_flags_LEGTNode *node = new (C) cmpL_reg_flags_LEGTNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case cmpL_LEGT_rule: {
      cmpL_LEGTNode *node = new (C) cmpL_LEGTNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUL_zero_flags_LEGT_rule: {
      cmpUL_zero_flags_LEGTNode *node = new (C) cmpUL_zero_flags_LEGTNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case cmpUL_reg_flags_LEGT_rule: {
      cmpUL_reg_flags_LEGTNode *node = new (C) cmpUL_reg_flags_LEGTNode();
      node->set_opnd_array(3, MachOperGenerator(RREGI, C));
      return node;
    }
  case cmpUL_LEGT_rule: {
      cmpUL_LEGTNode *node = new (C) cmpUL_LEGTNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmovLL_reg_LEGT_rule: {
      cmovLL_reg_LEGTNode *node = new (C) cmovLL_reg_LEGTNode();
      return node;
    }
  case cmovLL_mem_LEGT_rule: {
      cmovLL_mem_LEGTNode *node = new (C) cmovLL_mem_LEGTNode();
      return node;
    }
  case cmovII_reg_LEGT_rule: {
      cmovII_reg_LEGTNode *node = new (C) cmovII_reg_LEGTNode();
      return node;
    }
  case cmovII_mem_LEGT_rule: {
      cmovII_mem_LEGTNode *node = new (C) cmovII_mem_LEGTNode();
      return node;
    }
  case cmovPP_reg_LEGT_rule: {
      cmovPP_reg_LEGTNode *node = new (C) cmovPP_reg_LEGTNode();
      return node;
    }
  case cmovDDPR_reg_LEGT_rule: {
      cmovDDPR_reg_LEGTNode *node = new (C) cmovDDPR_reg_LEGTNode();
      return node;
    }
  case cmovDD_reg_LEGT_rule: {
      cmovDD_reg_LEGTNode *node = new (C) cmovDD_reg_LEGTNode();
      return node;
    }
  case cmovFFPR_reg_LEGT_rule: {
      cmovFFPR_reg_LEGTNode *node = new (C) cmovFFPR_reg_LEGTNode();
      return node;
    }
  case cmovFF_reg_LEGT_rule: {
      cmovFF_reg_LEGTNode *node = new (C) cmovFF_reg_LEGTNode();
      return node;
    }
  case CallStaticJavaDirect_rule: {
      CallStaticJavaDirectNode *node = new (C) CallStaticJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallDynamicJavaDirect_rule: {
      CallDynamicJavaDirectNode *node = new (C) CallDynamicJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallRuntimeDirect_rule: {
      CallRuntimeDirectNode *node = new (C) CallRuntimeDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallLeafDirect_rule: {
      CallLeafDirectNode *node = new (C) CallLeafDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallLeafNoFPDirect_rule: {
      CallLeafNoFPDirectNode *node = new (C) CallLeafNoFPDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case Ret_rule: {
      RetNode *node = new (C) RetNode();
      return node;
    }
  case TailCalljmpInd_rule: {
      TailCalljmpIndNode *node = new (C) TailCalljmpIndNode();
      return node;
    }
  case tailjmpInd_rule: {
      tailjmpIndNode *node = new (C) tailjmpIndNode();
      return node;
    }
  case CreateException_rule: {
      CreateExceptionNode *node = new (C) CreateExceptionNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case RethrowException_rule: {
      RethrowExceptionNode *node = new (C) RethrowExceptionNode();
      return node;
    }
  case cmpFastLockRTM_rule: {
      cmpFastLockRTMNode *node = new (C) cmpFastLockRTMNode();
      node->set_opnd_array(3, MachOperGenerator(EAXREGI, C));
      node->set_opnd_array(4, MachOperGenerator(EDXREGI, C));
      node->set_opnd_array(5, MachOperGenerator(RREGI, C));
      node->set_opnd_array(6, MachOperGenerator(RREGI, C));
      node->_counters = _leaf->as_FastLock()->counters();
      node->_rtm_counters = _leaf->as_FastLock()->rtm_counters();
      node->_stack_rtm_counters = _leaf->as_FastLock()->stack_rtm_counters();
      return node;
    }
  case cmpFastLock_rule: {
      cmpFastLockNode *node = new (C) cmpFastLockNode();
      node->set_opnd_array(3, MachOperGenerator(EAXREGI, C));
      node->set_opnd_array(4, MachOperGenerator(EREGP, C));
      node->_counters = _leaf->as_FastLock()->counters();
      node->_rtm_counters = _leaf->as_FastLock()->rtm_counters();
      node->_stack_rtm_counters = _leaf->as_FastLock()->stack_rtm_counters();
      return node;
    }
  case cmpFastUnlock_rule: {
      cmpFastUnlockNode *node = new (C) cmpFastUnlockNode();
      node->set_opnd_array(3, MachOperGenerator(EREGP, C));
      return node;
    }
  case safePoint_poll_rule: {
      safePoint_pollNode *node = new (C) safePoint_pollNode();
      node->set_opnd_array(1, MachOperGenerator(EFLAGSREG, C));
      return node;
    }
  case tlsLoadP_rule: {
      tlsLoadPNode *node = new (C) tlsLoadPNode();
      return node;
    }
  case ShouldNotReachHere_rule: {
      ShouldNotReachHereNode *node = new (C) ShouldNotReachHereNode();
      return node;
    }
  case addF_reg_rule: {
      addF_regNode *node = new (C) addF_regNode();
      return node;
    }
  case addF_mem_rule: {
      addF_memNode *node = new (C) addF_memNode();
      return node;
    }
  case addF_mem_0_rule: {
      addF_mem_0Node *node = new (C) addF_mem_0Node();
      return node;
    }
  case addF_imm_rule: {
      addF_immNode *node = new (C) addF_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addF_reg_reg_rule: {
      addF_reg_regNode *node = new (C) addF_reg_regNode();
      return node;
    }
  case addF_reg_mem_rule: {
      addF_reg_memNode *node = new (C) addF_reg_memNode();
      return node;
    }
  case addF_reg_mem_0_rule: {
      addF_reg_mem_0Node *node = new (C) addF_reg_mem_0Node();
      return node;
    }
  case addF_reg_imm_rule: {
      addF_reg_immNode *node = new (C) addF_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addD_reg_rule: {
      addD_regNode *node = new (C) addD_regNode();
      return node;
    }
  case addD_mem_rule: {
      addD_memNode *node = new (C) addD_memNode();
      return node;
    }
  case addD_mem_0_rule: {
      addD_mem_0Node *node = new (C) addD_mem_0Node();
      return node;
    }
  case addD_imm_rule: {
      addD_immNode *node = new (C) addD_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addD_reg_reg_rule: {
      addD_reg_regNode *node = new (C) addD_reg_regNode();
      return node;
    }
  case addD_reg_mem_rule: {
      addD_reg_memNode *node = new (C) addD_reg_memNode();
      return node;
    }
  case addD_reg_mem_0_rule: {
      addD_reg_mem_0Node *node = new (C) addD_reg_mem_0Node();
      return node;
    }
  case addD_reg_imm_rule: {
      addD_reg_immNode *node = new (C) addD_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subF_reg_rule: {
      subF_regNode *node = new (C) subF_regNode();
      return node;
    }
  case subF_mem_rule: {
      subF_memNode *node = new (C) subF_memNode();
      return node;
    }
  case subF_imm_rule: {
      subF_immNode *node = new (C) subF_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subF_reg_reg_rule: {
      subF_reg_regNode *node = new (C) subF_reg_regNode();
      return node;
    }
  case subF_reg_mem_rule: {
      subF_reg_memNode *node = new (C) subF_reg_memNode();
      return node;
    }
  case subF_reg_imm_rule: {
      subF_reg_immNode *node = new (C) subF_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subD_reg_rule: {
      subD_regNode *node = new (C) subD_regNode();
      return node;
    }
  case subD_mem_rule: {
      subD_memNode *node = new (C) subD_memNode();
      return node;
    }
  case subD_imm_rule: {
      subD_immNode *node = new (C) subD_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case subD_reg_reg_rule: {
      subD_reg_regNode *node = new (C) subD_reg_regNode();
      return node;
    }
  case subD_reg_mem_rule: {
      subD_reg_memNode *node = new (C) subD_reg_memNode();
      return node;
    }
  case subD_reg_imm_rule: {
      subD_reg_immNode *node = new (C) subD_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulF_reg_rule: {
      mulF_regNode *node = new (C) mulF_regNode();
      return node;
    }
  case mulF_mem_rule: {
      mulF_memNode *node = new (C) mulF_memNode();
      return node;
    }
  case mulF_mem_0_rule: {
      mulF_mem_0Node *node = new (C) mulF_mem_0Node();
      return node;
    }
  case mulF_imm_rule: {
      mulF_immNode *node = new (C) mulF_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulF_reg_reg_rule: {
      mulF_reg_regNode *node = new (C) mulF_reg_regNode();
      return node;
    }
  case mulF_reg_mem_rule: {
      mulF_reg_memNode *node = new (C) mulF_reg_memNode();
      return node;
    }
  case mulF_reg_mem_0_rule: {
      mulF_reg_mem_0Node *node = new (C) mulF_reg_mem_0Node();
      return node;
    }
  case mulF_reg_imm_rule: {
      mulF_reg_immNode *node = new (C) mulF_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulD_reg_rule: {
      mulD_regNode *node = new (C) mulD_regNode();
      return node;
    }
  case mulD_mem_rule: {
      mulD_memNode *node = new (C) mulD_memNode();
      return node;
    }
  case mulD_mem_0_rule: {
      mulD_mem_0Node *node = new (C) mulD_mem_0Node();
      return node;
    }
  case mulD_imm_rule: {
      mulD_immNode *node = new (C) mulD_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case mulD_reg_reg_rule: {
      mulD_reg_regNode *node = new (C) mulD_reg_regNode();
      return node;
    }
  case mulD_reg_mem_rule: {
      mulD_reg_memNode *node = new (C) mulD_reg_memNode();
      return node;
    }
  case mulD_reg_mem_0_rule: {
      mulD_reg_mem_0Node *node = new (C) mulD_reg_mem_0Node();
      return node;
    }
  case mulD_reg_imm_rule: {
      mulD_reg_immNode *node = new (C) mulD_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case divF_reg_rule: {
      divF_regNode *node = new (C) divF_regNode();
      return node;
    }
  case divF_mem_rule: {
      divF_memNode *node = new (C) divF_memNode();
      return node;
    }
  case divF_imm_rule: {
      divF_immNode *node = new (C) divF_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case divF_reg_reg_rule: {
      divF_reg_regNode *node = new (C) divF_reg_regNode();
      return node;
    }
  case divF_reg_mem_rule: {
      divF_reg_memNode *node = new (C) divF_reg_memNode();
      return node;
    }
  case divF_reg_imm_rule: {
      divF_reg_immNode *node = new (C) divF_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case divD_reg_rule: {
      divD_regNode *node = new (C) divD_regNode();
      return node;
    }
  case divD_mem_rule: {
      divD_memNode *node = new (C) divD_memNode();
      return node;
    }
  case divD_imm_rule: {
      divD_immNode *node = new (C) divD_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case divD_reg_reg_rule: {
      divD_reg_regNode *node = new (C) divD_reg_regNode();
      return node;
    }
  case divD_reg_mem_rule: {
      divD_reg_memNode *node = new (C) divD_reg_memNode();
      return node;
    }
  case divD_reg_imm_rule: {
      divD_reg_immNode *node = new (C) divD_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case absF_reg_rule: {
      absF_regNode *node = new (C) absF_regNode();
      return node;
    }
  case absF_reg_reg_rule: {
      absF_reg_regNode *node = new (C) absF_reg_regNode();
      return node;
    }
  case absD_reg_rule: {
      absD_regNode *node = new (C) absD_regNode();
      return node;
    }
  case absD_reg_reg_rule: {
      absD_reg_regNode *node = new (C) absD_reg_regNode();
      return node;
    }
  case negF_reg_rule: {
      negF_regNode *node = new (C) negF_regNode();
      return node;
    }
  case negF_reg_reg_rule: {
      negF_reg_regNode *node = new (C) negF_reg_regNode();
      return node;
    }
  case negD_reg_rule: {
      negD_regNode *node = new (C) negD_regNode();
      return node;
    }
  case negD_reg_reg_rule: {
      negD_reg_regNode *node = new (C) negD_reg_regNode();
      return node;
    }
  case sqrtF_reg_rule: {
      sqrtF_regNode *node = new (C) sqrtF_regNode();
      return node;
    }
  case sqrtF_mem_rule: {
      sqrtF_memNode *node = new (C) sqrtF_memNode();
      return node;
    }
  case sqrtF_imm_rule: {
      sqrtF_immNode *node = new (C) sqrtF_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case sqrtD_reg_rule: {
      sqrtD_regNode *node = new (C) sqrtD_regNode();
      return node;
    }
  case sqrtD_mem_rule: {
      sqrtD_memNode *node = new (C) sqrtD_memNode();
      return node;
    }
  case sqrtD_imm_rule: {
      sqrtD_immNode *node = new (C) sqrtD_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadV4_rule: {
      loadV4Node *node = new (C) loadV4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadV8_rule: {
      loadV8Node *node = new (C) loadV8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadV16_rule: {
      loadV16Node *node = new (C) loadV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadV32_rule: {
      loadV32Node *node = new (C) loadV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV4_rule: {
      storeV4Node *node = new (C) storeV4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV8_rule: {
      storeV8Node *node = new (C) storeV8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV16_rule: {
      storeV16Node *node = new (C) storeV16Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV32_rule: {
      storeV32Node *node = new (C) storeV32Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4B_rule: {
      Repl4BNode *node = new (C) Repl4BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_rule: {
      Repl8BNode *node = new (C) Repl8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16B_rule: {
      Repl16BNode *node = new (C) Repl16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32B_rule: {
      Repl32BNode *node = new (C) Repl32BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4B_imm_rule: {
      Repl4B_immNode *node = new (C) Repl4B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_imm_rule: {
      Repl8B_immNode *node = new (C) Repl8B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16B_imm_rule: {
      Repl16B_immNode *node = new (C) Repl16B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32B_imm_rule: {
      Repl32B_immNode *node = new (C) Repl32B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4B_zero_rule: {
      Repl4B_zeroNode *node = new (C) Repl4B_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_zero_rule: {
      Repl8B_zeroNode *node = new (C) Repl8B_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16B_zero_rule: {
      Repl16B_zeroNode *node = new (C) Repl16B_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl32B_zero_rule: {
      Repl32B_zeroNode *node = new (C) Repl32B_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2S_rule: {
      Repl2SNode *node = new (C) Repl2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_rule: {
      Repl4SNode *node = new (C) Repl4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8S_rule: {
      Repl8SNode *node = new (C) Repl8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16S_rule: {
      Repl16SNode *node = new (C) Repl16SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2S_imm_rule: {
      Repl2S_immNode *node = new (C) Repl2S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_imm_rule: {
      Repl4S_immNode *node = new (C) Repl4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8S_imm_rule: {
      Repl8S_immNode *node = new (C) Repl8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16S_imm_rule: {
      Repl16S_immNode *node = new (C) Repl16S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2S_zero_rule: {
      Repl2S_zeroNode *node = new (C) Repl2S_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_zero_rule: {
      Repl4S_zeroNode *node = new (C) Repl4S_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8S_zero_rule: {
      Repl8S_zeroNode *node = new (C) Repl8S_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl16S_zero_rule: {
      Repl16S_zeroNode *node = new (C) Repl16S_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2I_rule: {
      Repl2INode *node = new (C) Repl2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4I_rule: {
      Repl4INode *node = new (C) Repl4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8I_rule: {
      Repl8INode *node = new (C) Repl8INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2I_imm_rule: {
      Repl2I_immNode *node = new (C) Repl2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4I_imm_rule: {
      Repl4I_immNode *node = new (C) Repl4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8I_imm_rule: {
      Repl8I_immNode *node = new (C) Repl8I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2I_mem_rule: {
      Repl2I_memNode *node = new (C) Repl2I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4I_mem_rule: {
      Repl4I_memNode *node = new (C) Repl4I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8I_mem_rule: {
      Repl8I_memNode *node = new (C) Repl8I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2I_zero_rule: {
      Repl2I_zeroNode *node = new (C) Repl2I_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4I_zero_rule: {
      Repl4I_zeroNode *node = new (C) Repl4I_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8I_zero_rule: {
      Repl8I_zeroNode *node = new (C) Repl8I_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2L_rule: {
      Repl2LNode *node = new (C) Repl2LNode();
      node->set_opnd_array(2, MachOperGenerator(VECX, C));
      node->set_opnd_array(3, MachOperGenerator(REGD, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4L_rule: {
      Repl4LNode *node = new (C) Repl4LNode();
      node->set_opnd_array(2, MachOperGenerator(VECY, C));
      node->set_opnd_array(3, MachOperGenerator(REGD, C));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2L_imm_rule: {
      Repl2L_immNode *node = new (C) Repl2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4L_imm_rule: {
      Repl4L_immNode *node = new (C) Repl4L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2L_mem_rule: {
      Repl2L_memNode *node = new (C) Repl2L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4L_mem_rule: {
      Repl4L_memNode *node = new (C) Repl4L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2L_zero_rule: {
      Repl2L_zeroNode *node = new (C) Repl2L_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4L_zero_rule: {
      Repl4L_zeroNode *node = new (C) Repl4L_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2F_rule: {
      Repl2FNode *node = new (C) Repl2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4F_rule: {
      Repl4FNode *node = new (C) Repl4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8F_rule: {
      Repl8FNode *node = new (C) Repl8FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2F_zero_rule: {
      Repl2F_zeroNode *node = new (C) Repl2F_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4F_zero_rule: {
      Repl4F_zeroNode *node = new (C) Repl4F_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8F_zero_rule: {
      Repl8F_zeroNode *node = new (C) Repl8F_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2D_rule: {
      Repl2DNode *node = new (C) Repl2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4D_rule: {
      Repl4DNode *node = new (C) Repl4DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2D_zero_rule: {
      Repl2D_zeroNode *node = new (C) Repl2D_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4D_zero_rule: {
      Repl4D_zeroNode *node = new (C) Repl4D_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4B_rule: {
      vadd4BNode *node = new (C) vadd4BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4B_reg_rule: {
      vadd4B_regNode *node = new (C) vadd4B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8B_rule: {
      vadd8BNode *node = new (C) vadd8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8B_reg_rule: {
      vadd8B_regNode *node = new (C) vadd8B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16B_rule: {
      vadd16BNode *node = new (C) vadd16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16B_reg_rule: {
      vadd16B_regNode *node = new (C) vadd16B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16B_mem_rule: {
      vadd16B_memNode *node = new (C) vadd16B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd32B_reg_rule: {
      vadd32B_regNode *node = new (C) vadd32B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd32B_mem_rule: {
      vadd32B_memNode *node = new (C) vadd32B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2S_rule: {
      vadd2SNode *node = new (C) vadd2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2S_reg_rule: {
      vadd2S_regNode *node = new (C) vadd2S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4S_rule: {
      vadd4SNode *node = new (C) vadd4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4S_reg_rule: {
      vadd4S_regNode *node = new (C) vadd4S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8S_rule: {
      vadd8SNode *node = new (C) vadd8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8S_reg_rule: {
      vadd8S_regNode *node = new (C) vadd8S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8S_mem_rule: {
      vadd8S_memNode *node = new (C) vadd8S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16S_reg_rule: {
      vadd16S_regNode *node = new (C) vadd16S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd16S_mem_rule: {
      vadd16S_memNode *node = new (C) vadd16S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2I_rule: {
      vadd2INode *node = new (C) vadd2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2I_reg_rule: {
      vadd2I_regNode *node = new (C) vadd2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4I_rule: {
      vadd4INode *node = new (C) vadd4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4I_reg_rule: {
      vadd4I_regNode *node = new (C) vadd4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4I_mem_rule: {
      vadd4I_memNode *node = new (C) vadd4I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8I_reg_rule: {
      vadd8I_regNode *node = new (C) vadd8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8I_mem_rule: {
      vadd8I_memNode *node = new (C) vadd8I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2L_rule: {
      vadd2LNode *node = new (C) vadd2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2L_reg_rule: {
      vadd2L_regNode *node = new (C) vadd2L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2L_mem_rule: {
      vadd2L_memNode *node = new (C) vadd2L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4L_reg_rule: {
      vadd4L_regNode *node = new (C) vadd4L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4L_mem_rule: {
      vadd4L_memNode *node = new (C) vadd4L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2F_rule: {
      vadd2FNode *node = new (C) vadd2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2F_reg_rule: {
      vadd2F_regNode *node = new (C) vadd2F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4F_rule: {
      vadd4FNode *node = new (C) vadd4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4F_reg_rule: {
      vadd4F_regNode *node = new (C) vadd4F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4F_mem_rule: {
      vadd4F_memNode *node = new (C) vadd4F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8F_reg_rule: {
      vadd8F_regNode *node = new (C) vadd8F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd8F_mem_rule: {
      vadd8F_memNode *node = new (C) vadd8F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2D_rule: {
      vadd2DNode *node = new (C) vadd2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2D_reg_rule: {
      vadd2D_regNode *node = new (C) vadd2D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2D_mem_rule: {
      vadd2D_memNode *node = new (C) vadd2D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4D_reg_rule: {
      vadd4D_regNode *node = new (C) vadd4D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd4D_mem_rule: {
      vadd4D_memNode *node = new (C) vadd4D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4B_rule: {
      vsub4BNode *node = new (C) vsub4BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4B_reg_rule: {
      vsub4B_regNode *node = new (C) vsub4B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8B_rule: {
      vsub8BNode *node = new (C) vsub8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8B_reg_rule: {
      vsub8B_regNode *node = new (C) vsub8B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16B_rule: {
      vsub16BNode *node = new (C) vsub16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16B_reg_rule: {
      vsub16B_regNode *node = new (C) vsub16B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16B_mem_rule: {
      vsub16B_memNode *node = new (C) vsub16B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub32B_reg_rule: {
      vsub32B_regNode *node = new (C) vsub32B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub32B_mem_rule: {
      vsub32B_memNode *node = new (C) vsub32B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2S_rule: {
      vsub2SNode *node = new (C) vsub2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2S_reg_rule: {
      vsub2S_regNode *node = new (C) vsub2S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4S_rule: {
      vsub4SNode *node = new (C) vsub4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4S_reg_rule: {
      vsub4S_regNode *node = new (C) vsub4S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8S_rule: {
      vsub8SNode *node = new (C) vsub8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8S_reg_rule: {
      vsub8S_regNode *node = new (C) vsub8S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8S_mem_rule: {
      vsub8S_memNode *node = new (C) vsub8S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16S_reg_rule: {
      vsub16S_regNode *node = new (C) vsub16S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub16S_mem_rule: {
      vsub16S_memNode *node = new (C) vsub16S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2I_rule: {
      vsub2INode *node = new (C) vsub2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2I_reg_rule: {
      vsub2I_regNode *node = new (C) vsub2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4I_rule: {
      vsub4INode *node = new (C) vsub4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4I_reg_rule: {
      vsub4I_regNode *node = new (C) vsub4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4I_mem_rule: {
      vsub4I_memNode *node = new (C) vsub4I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8I_reg_rule: {
      vsub8I_regNode *node = new (C) vsub8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8I_mem_rule: {
      vsub8I_memNode *node = new (C) vsub8I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2L_rule: {
      vsub2LNode *node = new (C) vsub2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2L_reg_rule: {
      vsub2L_regNode *node = new (C) vsub2L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2L_mem_rule: {
      vsub2L_memNode *node = new (C) vsub2L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4L_reg_rule: {
      vsub4L_regNode *node = new (C) vsub4L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4L_mem_rule: {
      vsub4L_memNode *node = new (C) vsub4L_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2F_rule: {
      vsub2FNode *node = new (C) vsub2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2F_reg_rule: {
      vsub2F_regNode *node = new (C) vsub2F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4F_rule: {
      vsub4FNode *node = new (C) vsub4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4F_reg_rule: {
      vsub4F_regNode *node = new (C) vsub4F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4F_mem_rule: {
      vsub4F_memNode *node = new (C) vsub4F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8F_reg_rule: {
      vsub8F_regNode *node = new (C) vsub8F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub8F_mem_rule: {
      vsub8F_memNode *node = new (C) vsub8F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2D_rule: {
      vsub2DNode *node = new (C) vsub2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2D_reg_rule: {
      vsub2D_regNode *node = new (C) vsub2D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2D_mem_rule: {
      vsub2D_memNode *node = new (C) vsub2D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4D_reg_rule: {
      vsub4D_regNode *node = new (C) vsub4D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub4D_mem_rule: {
      vsub4D_memNode *node = new (C) vsub4D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2S_rule: {
      vmul2SNode *node = new (C) vmul2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2S_reg_rule: {
      vmul2S_regNode *node = new (C) vmul2S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4S_rule: {
      vmul4SNode *node = new (C) vmul4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4S_reg_rule: {
      vmul4S_regNode *node = new (C) vmul4S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8S_rule: {
      vmul8SNode *node = new (C) vmul8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8S_reg_rule: {
      vmul8S_regNode *node = new (C) vmul8S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8S_mem_rule: {
      vmul8S_memNode *node = new (C) vmul8S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul16S_reg_rule: {
      vmul16S_regNode *node = new (C) vmul16S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul16S_mem_rule: {
      vmul16S_memNode *node = new (C) vmul16S_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2I_rule: {
      vmul2INode *node = new (C) vmul2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2I_reg_rule: {
      vmul2I_regNode *node = new (C) vmul2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4I_rule: {
      vmul4INode *node = new (C) vmul4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4I_reg_rule: {
      vmul4I_regNode *node = new (C) vmul4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4I_mem_rule: {
      vmul4I_memNode *node = new (C) vmul4I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8I_reg_rule: {
      vmul8I_regNode *node = new (C) vmul8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8I_mem_rule: {
      vmul8I_memNode *node = new (C) vmul8I_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2F_rule: {
      vmul2FNode *node = new (C) vmul2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2F_reg_rule: {
      vmul2F_regNode *node = new (C) vmul2F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4F_rule: {
      vmul4FNode *node = new (C) vmul4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4F_reg_rule: {
      vmul4F_regNode *node = new (C) vmul4F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4F_mem_rule: {
      vmul4F_memNode *node = new (C) vmul4F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8F_reg_rule: {
      vmul8F_regNode *node = new (C) vmul8F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul8F_mem_rule: {
      vmul8F_memNode *node = new (C) vmul8F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2D_rule: {
      vmul2DNode *node = new (C) vmul2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2D_reg_rule: {
      vmul2D_regNode *node = new (C) vmul2D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2D_mem_rule: {
      vmul2D_memNode *node = new (C) vmul2D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4D_reg_rule: {
      vmul4D_regNode *node = new (C) vmul4D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul4D_mem_rule: {
      vmul4D_memNode *node = new (C) vmul4D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2F_rule: {
      vdiv2FNode *node = new (C) vdiv2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2F_reg_rule: {
      vdiv2F_regNode *node = new (C) vdiv2F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv4F_rule: {
      vdiv4FNode *node = new (C) vdiv4FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv4F_reg_rule: {
      vdiv4F_regNode *node = new (C) vdiv4F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv4F_mem_rule: {
      vdiv4F_memNode *node = new (C) vdiv4F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv8F_reg_rule: {
      vdiv8F_regNode *node = new (C) vdiv8F_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv8F_mem_rule: {
      vdiv8F_memNode *node = new (C) vdiv8F_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2D_rule: {
      vdiv2DNode *node = new (C) vdiv2DNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2D_reg_rule: {
      vdiv2D_regNode *node = new (C) vdiv2D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv2D_mem_rule: {
      vdiv2D_memNode *node = new (C) vdiv2D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv4D_reg_rule: {
      vdiv4D_regNode *node = new (C) vdiv4D_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdiv4D_mem_rule: {
      vdiv4D_memNode *node = new (C) vdiv4D_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcnt_rule: {
      vshiftcntNode *node = new (C) vshiftcntNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcnt_0_rule: {
      vshiftcnt_0Node *node = new (C) vshiftcnt_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2S_rule: {
      vsll2SNode *node = new (C) vsll2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2S_imm_rule: {
      vsll2S_immNode *node = new (C) vsll2S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2S_reg_rule: {
      vsll2S_regNode *node = new (C) vsll2S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2S_reg_imm_rule: {
      vsll2S_reg_immNode *node = new (C) vsll2S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4S_rule: {
      vsll4SNode *node = new (C) vsll4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4S_imm_rule: {
      vsll4S_immNode *node = new (C) vsll4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4S_reg_rule: {
      vsll4S_regNode *node = new (C) vsll4S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4S_reg_imm_rule: {
      vsll4S_reg_immNode *node = new (C) vsll4S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8S_rule: {
      vsll8SNode *node = new (C) vsll8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8S_imm_rule: {
      vsll8S_immNode *node = new (C) vsll8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8S_reg_rule: {
      vsll8S_regNode *node = new (C) vsll8S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8S_reg_imm_rule: {
      vsll8S_reg_immNode *node = new (C) vsll8S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll16S_reg_rule: {
      vsll16S_regNode *node = new (C) vsll16S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll16S_reg_imm_rule: {
      vsll16S_reg_immNode *node = new (C) vsll16S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2I_rule: {
      vsll2INode *node = new (C) vsll2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2I_imm_rule: {
      vsll2I_immNode *node = new (C) vsll2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2I_reg_rule: {
      vsll2I_regNode *node = new (C) vsll2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2I_reg_imm_rule: {
      vsll2I_reg_immNode *node = new (C) vsll2I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4I_rule: {
      vsll4INode *node = new (C) vsll4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4I_imm_rule: {
      vsll4I_immNode *node = new (C) vsll4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4I_reg_rule: {
      vsll4I_regNode *node = new (C) vsll4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4I_reg_imm_rule: {
      vsll4I_reg_immNode *node = new (C) vsll4I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8I_reg_rule: {
      vsll8I_regNode *node = new (C) vsll8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll8I_reg_imm_rule: {
      vsll8I_reg_immNode *node = new (C) vsll8I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2L_rule: {
      vsll2LNode *node = new (C) vsll2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2L_imm_rule: {
      vsll2L_immNode *node = new (C) vsll2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2L_reg_rule: {
      vsll2L_regNode *node = new (C) vsll2L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll2L_reg_imm_rule: {
      vsll2L_reg_immNode *node = new (C) vsll2L_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4L_reg_rule: {
      vsll4L_regNode *node = new (C) vsll4L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsll4L_reg_imm_rule: {
      vsll4L_reg_immNode *node = new (C) vsll4L_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2S_rule: {
      vsrl2SNode *node = new (C) vsrl2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2S_imm_rule: {
      vsrl2S_immNode *node = new (C) vsrl2S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2S_reg_rule: {
      vsrl2S_regNode *node = new (C) vsrl2S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2S_reg_imm_rule: {
      vsrl2S_reg_immNode *node = new (C) vsrl2S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4S_rule: {
      vsrl4SNode *node = new (C) vsrl4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4S_imm_rule: {
      vsrl4S_immNode *node = new (C) vsrl4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4S_reg_rule: {
      vsrl4S_regNode *node = new (C) vsrl4S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4S_reg_imm_rule: {
      vsrl4S_reg_immNode *node = new (C) vsrl4S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8S_rule: {
      vsrl8SNode *node = new (C) vsrl8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8S_imm_rule: {
      vsrl8S_immNode *node = new (C) vsrl8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8S_reg_rule: {
      vsrl8S_regNode *node = new (C) vsrl8S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8S_reg_imm_rule: {
      vsrl8S_reg_immNode *node = new (C) vsrl8S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl16S_reg_rule: {
      vsrl16S_regNode *node = new (C) vsrl16S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl16S_reg_imm_rule: {
      vsrl16S_reg_immNode *node = new (C) vsrl16S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2I_rule: {
      vsrl2INode *node = new (C) vsrl2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2I_imm_rule: {
      vsrl2I_immNode *node = new (C) vsrl2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2I_reg_rule: {
      vsrl2I_regNode *node = new (C) vsrl2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2I_reg_imm_rule: {
      vsrl2I_reg_immNode *node = new (C) vsrl2I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4I_rule: {
      vsrl4INode *node = new (C) vsrl4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4I_imm_rule: {
      vsrl4I_immNode *node = new (C) vsrl4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4I_reg_rule: {
      vsrl4I_regNode *node = new (C) vsrl4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4I_reg_imm_rule: {
      vsrl4I_reg_immNode *node = new (C) vsrl4I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8I_reg_rule: {
      vsrl8I_regNode *node = new (C) vsrl8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl8I_reg_imm_rule: {
      vsrl8I_reg_immNode *node = new (C) vsrl8I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2L_rule: {
      vsrl2LNode *node = new (C) vsrl2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2L_imm_rule: {
      vsrl2L_immNode *node = new (C) vsrl2L_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2L_reg_rule: {
      vsrl2L_regNode *node = new (C) vsrl2L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl2L_reg_imm_rule: {
      vsrl2L_reg_immNode *node = new (C) vsrl2L_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4L_reg_rule: {
      vsrl4L_regNode *node = new (C) vsrl4L_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsrl4L_reg_imm_rule: {
      vsrl4L_reg_immNode *node = new (C) vsrl4L_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2S_rule: {
      vsra2SNode *node = new (C) vsra2SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2S_imm_rule: {
      vsra2S_immNode *node = new (C) vsra2S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2S_reg_rule: {
      vsra2S_regNode *node = new (C) vsra2S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2S_reg_imm_rule: {
      vsra2S_reg_immNode *node = new (C) vsra2S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4S_rule: {
      vsra4SNode *node = new (C) vsra4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4S_imm_rule: {
      vsra4S_immNode *node = new (C) vsra4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4S_reg_rule: {
      vsra4S_regNode *node = new (C) vsra4S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4S_reg_imm_rule: {
      vsra4S_reg_immNode *node = new (C) vsra4S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8S_rule: {
      vsra8SNode *node = new (C) vsra8SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8S_imm_rule: {
      vsra8S_immNode *node = new (C) vsra8S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8S_reg_rule: {
      vsra8S_regNode *node = new (C) vsra8S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8S_reg_imm_rule: {
      vsra8S_reg_immNode *node = new (C) vsra8S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra16S_reg_rule: {
      vsra16S_regNode *node = new (C) vsra16S_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra16S_reg_imm_rule: {
      vsra16S_reg_immNode *node = new (C) vsra16S_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2I_rule: {
      vsra2INode *node = new (C) vsra2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2I_imm_rule: {
      vsra2I_immNode *node = new (C) vsra2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2I_reg_rule: {
      vsra2I_regNode *node = new (C) vsra2I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra2I_reg_imm_rule: {
      vsra2I_reg_immNode *node = new (C) vsra2I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4I_rule: {
      vsra4INode *node = new (C) vsra4INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4I_imm_rule: {
      vsra4I_immNode *node = new (C) vsra4I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4I_reg_rule: {
      vsra4I_regNode *node = new (C) vsra4I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra4I_reg_imm_rule: {
      vsra4I_reg_immNode *node = new (C) vsra4I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8I_reg_rule: {
      vsra8I_regNode *node = new (C) vsra8I_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsra8I_reg_imm_rule: {
      vsra8I_reg_immNode *node = new (C) vsra8I_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand4B_rule: {
      vand4BNode *node = new (C) vand4BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand4B_reg_rule: {
      vand4B_regNode *node = new (C) vand4B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand8B_rule: {
      vand8BNode *node = new (C) vand8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand8B_reg_rule: {
      vand8B_regNode *node = new (C) vand8B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand16B_rule: {
      vand16BNode *node = new (C) vand16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand16B_reg_rule: {
      vand16B_regNode *node = new (C) vand16B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand16B_mem_rule: {
      vand16B_memNode *node = new (C) vand16B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand32B_reg_rule: {
      vand32B_regNode *node = new (C) vand32B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand32B_mem_rule: {
      vand32B_memNode *node = new (C) vand32B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor4B_rule: {
      vor4BNode *node = new (C) vor4BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor4B_reg_rule: {
      vor4B_regNode *node = new (C) vor4B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor8B_rule: {
      vor8BNode *node = new (C) vor8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor8B_reg_rule: {
      vor8B_regNode *node = new (C) vor8B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor16B_rule: {
      vor16BNode *node = new (C) vor16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor16B_reg_rule: {
      vor16B_regNode *node = new (C) vor16B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor16B_mem_rule: {
      vor16B_memNode *node = new (C) vor16B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor32B_reg_rule: {
      vor32B_regNode *node = new (C) vor32B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor32B_mem_rule: {
      vor32B_memNode *node = new (C) vor32B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor4B_rule: {
      vxor4BNode *node = new (C) vxor4BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor4B_reg_rule: {
      vxor4B_regNode *node = new (C) vxor4B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor8B_rule: {
      vxor8BNode *node = new (C) vxor8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor8B_reg_rule: {
      vxor8B_regNode *node = new (C) vxor8B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor16B_rule: {
      vxor16BNode *node = new (C) vxor16BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor16B_reg_rule: {
      vxor16B_regNode *node = new (C) vxor16B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor16B_mem_rule: {
      vxor16B_memNode *node = new (C) vxor16B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor32B_reg_rule: {
      vxor32B_regNode *node = new (C) vxor32B_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor32B_mem_rule: {
      vxor32B_memNode *node = new (C) vxor32B_memNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  
  default:
    fprintf(stderr, "Default MachNode Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  };
  return NULL;
}
// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DIA32=1
#ifndef IA32
#  error "IA32 must be defined"
#endif // IA32
// Check adlc -U_LP64
#ifdef _LP64
#  error "_LP64 must not be defined"
#endif // _LP64
